searchData={"items":[{"type":"module","title":"Electric","doc":"","ref":"Electric.html"},{"type":"function","title":"Electric.instance_id/0","doc":"Every electric cluster belongs to a particular console database instance\n\nThis is that database instance id","ref":"Electric.html#instance_id/0"},{"type":"function","title":"Electric.version/0","doc":"","ref":"Electric.html#version/0"},{"type":"type","title":"Electric.relation/0","doc":"","ref":"Electric.html#t:relation/0"},{"type":"type","title":"Electric.relation_id/0","doc":"","ref":"Electric.html#t:relation_id/0"},{"type":"module","title":"Electric.Application","doc":"","ref":"Electric.Application.html"},{"type":"function","title":"Electric.Application.start/2","doc":"This callback starts the entire application, but is configured to run only when\nthis app is started on it's own, not as a library. As such, this should be the only\nplace that actually reads from `Application.get_env/2`, because it's the only context\nwhere the `config/runtime.exs` is executed.","ref":"Electric.Application.html#start/2"},{"type":"module","title":"Electric.ConcurrentStream","doc":"","ref":"Electric.ConcurrentStream.html"},{"type":"function","title":"Electric.ConcurrentStream.stream_to_end/1","doc":"Allows concurrent reading while writing of a stream.\nThere can be mutiple reading processes however there must be only one writing process.\n\nThe writing process must append an end marker to the end of the stream when it has finished\nto signal to the reading processes that the stream has ended.\n\nIf a read process runs out of data to read before the end marker has been written\nit waits the `poll_time_in_ms` for more data to be written, then resumes the stream\nwith the `stream_fun`.","ref":"Electric.ConcurrentStream.html#stream_to_end/1"},{"type":"module","title":"Electric.ConfigParser","doc":"","ref":"Electric.ConfigParser.html"},{"type":"function","title":"Electric.ConfigParser.parse_log_level/1","doc":"","ref":"Electric.ConfigParser.html#parse_log_level/1"},{"type":"function","title":"Electric.ConfigParser.parse_log_level!/1","doc":"","ref":"Electric.ConfigParser.html#parse_log_level!/1"},{"type":"function","title":"Electric.ConfigParser.parse_postgresql_uri/1","doc":"Parse a PostgreSQL URI into a keyword list.","ref":"Electric.ConfigParser.html#parse_postgresql_uri/1"},{"type":"function","title":"Examples - Electric.ConfigParser.parse_postgresql_uri/1","doc":"iex> parse_postgresql_uri(\"postgresql://postgres:password@example.com/app-db\")\n    {:ok, [\n      hostname: \"example.com\",\n      port: 5432,\n      database: \"app-db\",\n      username: \"postgres\",\n      password: \"password\",\n    ]}\n\n    iex> parse_postgresql_uri(\"postgresql://electric@192.168.111.33:81/__shadow\")\n    {:ok, [\n      hostname: \"192.168.111.33\",\n      port: 81,\n      database: \"__shadow\",\n      username: \"electric\"\n    ]}\n\n    iex> parse_postgresql_uri(\"postgresql://pg@[2001:db8::1234]:4321\")\n    {:ok, [\n      hostname: \"2001:db8::1234\",\n      port: 4321,\n      database: \"pg\",\n      username: \"pg\"\n    ]}\n\n    iex> parse_postgresql_uri(\"postgresql://user@localhost:5433/\")\n    {:ok, [\n      hostname: \"localhost\",\n      port: 5433,\n      database: \"user\",\n      username: \"user\"\n    ]}\n\n    iex> parse_postgresql_uri(\"postgresql://user%2Btesting%40gmail.com:weird%2Fpassword@localhost:5433/my%2Bdb%2Bname\")\n    {:ok, [\n      hostname: \"localhost\",\n      port: 5433,\n      database: \"my+db+name\",\n      username: \"user+testing@gmail.com\",\n      password: \"weird/password\"\n    ]}\n\n    iex> parse_postgresql_uri(\"postgres://super_user@localhost:7801/postgres?sslmode=disable\")\n    {:ok, [\n      hostname: \"localhost\",\n      port: 7801,\n      database: \"postgres\",\n      username: \"super_user\",\n      sslmode: :disable\n    ]}\n\n    iex> parse_postgresql_uri(\"postgres://super_user@localhost:7801/postgres?sslmode=require\")\n    {:ok, [\n      hostname: \"localhost\",\n      port: 7801,\n      database: \"postgres\",\n      username: \"super_user\",\n      sslmode: :require\n    ]}\n\n    iex> parse_postgresql_uri(\"postgres://super_user@localhost:7801/postgres?sslmode=yesplease\")\n    {:error, \"has invalid \\\"sslmode\\\" value: \\\"yesplease\\\"\"}\n\n    iex> parse_postgresql_uri(\"postgrex://localhost\")\n    {:error, \"has invalid URL scheme: \\\"postgrex\\\"\"}\n\n    iex> parse_postgresql_uri(\"postgresql://localhost\")\n    {:error, \"has invalid or missing username\"}\n\n    iex> parse_postgresql_uri(\"postgresql://:@localhost\")\n    {:error, \"has invalid or missing username\"}\n\n    iex> parse_postgresql_uri(\"postgresql://:password@localhost\")\n    {:error, \"has invalid or missing username\"}\n\n    iex> parse_postgresql_uri(\"postgresql://user:password\")\n    {:error, \"has invalid or missing username\"}\n\n    iex> parse_postgresql_uri(\"postgresql://user:password@\")\n    {:error, \"missing host\"}\n\n    iex> parse_postgresql_uri(\"postgresql://user@localhost:5433/mydb?opts=-c%20synchronous_commit%3Doff&foo=bar\")\n    {:error, \"has unsupported query options: \\\"foo\\\", \\\"opts\\\"\"}\n\n    iex> parse_postgresql_uri(\"postgresql://electric@localhost/db?replication=database\")\n    {:error, \"has unsupported \\\"replication\\\" query option. Electric opens both a replication connection and regular connections to Postgres as needed\"}\n\n    iex> parse_postgresql_uri(\"postgresql://electric@localhost/db?replication=off\")\n    {:error, \"has unsupported \\\"replication\\\" query option. Electric opens both a replication connection and regular connections to Postgres as needed\"}","ref":"Electric.ConfigParser.html#parse_postgresql_uri/1-examples"},{"type":"function","title":"Electric.ConfigParser.parse_postgresql_uri!/1","doc":"","ref":"Electric.ConfigParser.html#parse_postgresql_uri!/1"},{"type":"module","title":"Electric.Connection.Manager","doc":"Custom initialisation and reconnection logic for database connections.\n\nThis module is esentially a supervisor for database connections, implemented as a GenServer.\nUnlike an OTP process supervisor, it includes additional functionality:\n\n  - adjusting connection options based on the response from the database\n  - monitoring connections and initiating a reconnection procedure\n  - custom reconnection logic with exponential backoff\n  - starting the shape consumer supervisor tree once a database connection pool\n    has been initialized\n\nYour OTP application should start a singleton connection manager under its main supervision tree:\n\n    children = [\n      ...,\n      {Electric.Connection.Manager,\n       stack_id: ...,\n       connection_opts: [...],\n       replication_opts: [...],\n       pool_opts: [...],\n       timeline_opts: [...],\n       shape_cache_opts: [...]}\n    ]\n\n    Supervisor.start_link(children, strategy: :one_for_one)","ref":"Electric.Connection.Manager.html"},{"type":"function","title":"Electric.Connection.Manager.await_active/1","doc":"Only returns once the status is `:active`.\nIf the status is alredy active it returns immediately.\nThis is useful if you need to the connection pool to be running before proceeding.","ref":"Electric.Connection.Manager.html#await_active/1"},{"type":"function","title":"Electric.Connection.Manager.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Electric.Connection.Manager.html#child_spec/1"},{"type":"function","title":"Electric.Connection.Manager.drop_replication_slot_on_stop/1","doc":"","ref":"Electric.Connection.Manager.html#drop_replication_slot_on_stop/1"},{"type":"function","title":"Electric.Connection.Manager.exclusive_connection_lock_acquired/1","doc":"","ref":"Electric.Connection.Manager.html#exclusive_connection_lock_acquired/1"},{"type":"function","title":"Electric.Connection.Manager.get_pg_version/1","doc":"Returns the version of the PostgreSQL server.","ref":"Electric.Connection.Manager.html#get_pg_version/1"},{"type":"function","title":"Electric.Connection.Manager.get_status/1","doc":"Returns the status of the connection manager.","ref":"Electric.Connection.Manager.html#get_status/1"},{"type":"function","title":"Electric.Connection.Manager.name/1","doc":"","ref":"Electric.Connection.Manager.html#name/1"},{"type":"function","title":"Electric.Connection.Manager.pg_info_looked_up/2","doc":"","ref":"Electric.Connection.Manager.html#pg_info_looked_up/2"},{"type":"function","title":"Electric.Connection.Manager.report_retained_wal_size/1","doc":"","ref":"Electric.Connection.Manager.html#report_retained_wal_size/1"},{"type":"function","title":"Electric.Connection.Manager.start_link/1","doc":"","ref":"Electric.Connection.Manager.html#start_link/1"},{"type":"type","title":"Electric.Connection.Manager.option/0","doc":"","ref":"Electric.Connection.Manager.html#t:option/0"},{"type":"type","title":"Electric.Connection.Manager.options/0","doc":"","ref":"Electric.Connection.Manager.html#t:options/0"},{"type":"type","title":"Electric.Connection.Manager.status/0","doc":"","ref":"Electric.Connection.Manager.html#t:status/0"},{"type":"module","title":"Electric.Connection.Manager.State","doc":"","ref":"Electric.Connection.Manager.State.html"},{"type":"module","title":"Electric.Connection.Supervisor","doc":"The connection supervisor is a rest-for-one supervisor that starts `Connection.Manager`,\nfollowed by `Replication.Supervisor`.\n\nConnection.Manager monitors all of the connection process that it starts and if any one of\nthe goes down with a critical error (such as Postgres shutting down), the connection manager\nitself will shut down. This will cause the shutdown of Replication.Supervisor, due to the nature\nof the rest-for-one supervision strategy, and, since the latter supervisor is started as a\n`temporary` child of the connection supervisor, it won't be restarted until its child spec is\nre-added by a new call to `start_shapes_supervisor/0`.\n\nThis supervision design is deliberate: none of the \"shapes\" processes can function without a\nworking DB pool and we only have a DB pool when the Connection.Manager process can see that\nall of its database connections are healthy. Connection.Manager tries to reopen connections\nwhen they are closed, with an exponential backoff, so it is the first process to know when a\nconnection has been restored and it's also the one that starts Replication.Supervisor once it\nhas successfully initialized a database connection pool.","ref":"Electric.Connection.Supervisor.html"},{"type":"function","title":"Electric.Connection.Supervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Electric.Connection.Supervisor.html#child_spec/1"},{"type":"function","title":"Electric.Connection.Supervisor.init/1","doc":"","ref":"Electric.Connection.Supervisor.html#init/1"},{"type":"function","title":"Electric.Connection.Supervisor.name/1","doc":"","ref":"Electric.Connection.Supervisor.html#name/1"},{"type":"function","title":"Electric.Connection.Supervisor.start_link/1","doc":"","ref":"Electric.Connection.Supervisor.html#start_link/1"},{"type":"function","title":"Electric.Connection.Supervisor.start_shapes_supervisor/1","doc":"","ref":"Electric.Connection.Supervisor.html#start_shapes_supervisor/1"},{"type":"module","title":"Electric.LogItems","doc":"Defines the structure and how to create the items in the log that the electric client reads.\n\nThe log_item() data structure is a map for ease of consumption in the Elixir code,\nhowever when JSON encoded (not done in this module) it's the format that the electric\nclient accepts.","ref":"Electric.LogItems.html"},{"type":"function","title":"Electric.LogItems.from_change/4","doc":"","ref":"Electric.LogItems.html#from_change/4"},{"type":"function","title":"Electric.LogItems.from_snapshot_row_stream/4","doc":"","ref":"Electric.LogItems.html#from_snapshot_row_stream/4"},{"type":"type","title":"Electric.LogItems.log_item/0","doc":"","ref":"Electric.LogItems.html#t:log_item/0"},{"type":"protocol","title":"Electric.PersistentKV","doc":"","ref":"Electric.PersistentKV.html"},{"type":"function","title":"Electric.PersistentKV.get/2","doc":"","ref":"Electric.PersistentKV.html#get/2"},{"type":"function","title":"Electric.PersistentKV.set/3","doc":"","ref":"Electric.PersistentKV.html#set/3"},{"type":"type","title":"Electric.PersistentKV.t/0","doc":"All the types that implement this protocol.","ref":"Electric.PersistentKV.html#t:t/0"},{"type":"module","title":"Electric.PersistentKV.Filesystem","doc":"","ref":"Electric.PersistentKV.Filesystem.html"},{"type":"function","title":"Electric.PersistentKV.Filesystem.new!/1","doc":"","ref":"Electric.PersistentKV.Filesystem.html#new!/1"},{"type":"module","title":"Electric.PersistentKV.Memory","doc":"","ref":"Electric.PersistentKV.Memory.html"},{"type":"function","title":"Electric.PersistentKV.Memory.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Electric.PersistentKV.Memory.html#child_spec/1"},{"type":"function","title":"Electric.PersistentKV.Memory.contents/1","doc":"","ref":"Electric.PersistentKV.Memory.html#contents/1"},{"type":"function","title":"Electric.PersistentKV.Memory.new!/1","doc":"","ref":"Electric.PersistentKV.Memory.html#new!/1"},{"type":"function","title":"Electric.PersistentKV.Memory.start_link/1","doc":"","ref":"Electric.PersistentKV.Memory.html#start_link/1"},{"type":"type","title":"Electric.PersistentKV.Memory.seed_data/0","doc":"","ref":"Electric.PersistentKV.Memory.html#t:seed_data/0"},{"type":"type","title":"Electric.PersistentKV.Memory.t/0","doc":"","ref":"Electric.PersistentKV.Memory.html#t:t/0"},{"type":"module","title":"Electric.PersistentKV.Mock","doc":"","ref":"Electric.PersistentKV.Mock.html"},{"type":"function","title":"Electric.PersistentKV.Mock.new/0","doc":"","ref":"Electric.PersistentKV.Mock.html#new/0"},{"type":"type","title":"Electric.PersistentKV.Mock.t/0","doc":"","ref":"Electric.PersistentKV.Mock.html#t:t/0"},{"type":"module","title":"Electric.PersistentKV.Serialized","doc":"An implementation of PersistentKV that writes values serialised as JSON to the kv `backend`.","ref":"Electric.PersistentKV.Serialized.html"},{"type":"function","title":"Electric.PersistentKV.Serialized.new!/1","doc":"","ref":"Electric.PersistentKV.Serialized.html#new!/1"},{"type":"module","title":"Electric.Plug.DeleteShapePlug","doc":"","ref":"Electric.Plug.DeleteShapePlug.html"},{"type":"function","title":"Electric.Plug.DeleteShapePlug.call/2","doc":"","ref":"Electric.Plug.DeleteShapePlug.html#call/2"},{"type":"function","title":"Electric.Plug.DeleteShapePlug.init/1","doc":"","ref":"Electric.Plug.DeleteShapePlug.html#init/1"},{"type":"module","title":"Electric.Plug.HealthCheckPlug","doc":"","ref":"Electric.Plug.HealthCheckPlug.html"},{"type":"function","title":"Electric.Plug.HealthCheckPlug.call/2","doc":"","ref":"Electric.Plug.HealthCheckPlug.html#call/2"},{"type":"function","title":"Electric.Plug.HealthCheckPlug.init/1","doc":"","ref":"Electric.Plug.HealthCheckPlug.html#init/1"},{"type":"module","title":"Electric.Plug.LabelProcessPlug","doc":"A plug that assists debugging by labelling processes that handle requests with\ndetails about the request.\n\nThe plug should be places right after the match plug in the router:\n\n  plug :match\n  plug Electric.Plug.LabelProcessPlug","ref":"Electric.Plug.LabelProcessPlug.html"},{"type":"function","title":"Electric.Plug.LabelProcessPlug.call/2","doc":"","ref":"Electric.Plug.LabelProcessPlug.html#call/2"},{"type":"function","title":"Electric.Plug.LabelProcessPlug.init/1","doc":"","ref":"Electric.Plug.LabelProcessPlug.html#init/1"},{"type":"function","title":"Electric.Plug.LabelProcessPlug.process_label/1","doc":"Returns a description of the HTTP request to be used as the lable for the request process.","ref":"Electric.Plug.LabelProcessPlug.html#process_label/1"},{"type":"function","title":"Examples - Electric.Plug.LabelProcessPlug.process_label/1","doc":"iex> process_label(%{\n    ...>   method: \"GET\",\n    ...>   request_path: \"/v1/shape\",\n    ...>   query_string: \"table=users&offset=-1\",\n    ...>   assigns: %{plug_request_id: \"F-jPUudNHxbD8lIAABQG\"}\n    ...> })\n    \"Request F-jPUudNHxbD8lIAABQG - GET /v1/shape?table=users&offset=-1\"\n\n    iex> process_label(%{\n    ...>   method: \"GET\",\n    ...>   request_path: \"/v1/shape\",\n    ...>   query_string: \"table=users\",\n    ...>   assigns: %{plug_request_id: \"F-jPUudNHxbD8lIAABQG\"}\n    ...> })\n    \"Request F-jPUudNHxbD8lIAABQG - GET /v1/shape?table=users\"","ref":"Electric.Plug.LabelProcessPlug.html#process_label/1-examples"},{"type":"module","title":"Electric.Plug.OptionsShapePlug","doc":"","ref":"Electric.Plug.OptionsShapePlug.html"},{"type":"function","title":"Electric.Plug.OptionsShapePlug.call/2","doc":"","ref":"Electric.Plug.OptionsShapePlug.html#call/2"},{"type":"function","title":"Electric.Plug.OptionsShapePlug.init/1","doc":"","ref":"Electric.Plug.OptionsShapePlug.html#init/1"},{"type":"module","title":"Electric.Plug.Router","doc":"","ref":"Electric.Plug.Router.html"},{"type":"function","title":"Electric.Plug.Router.call/2","doc":"","ref":"Electric.Plug.Router.html#call/2"},{"type":"function","title":"Electric.Plug.Router.init/1","doc":"","ref":"Electric.Plug.Router.html#init/1"},{"type":"function","title":"Electric.Plug.Router.put_cors_headers/2","doc":"","ref":"Electric.Plug.Router.html#put_cors_headers/2"},{"type":"function","title":"Electric.Plug.Router.server_header/2","doc":"","ref":"Electric.Plug.Router.html#server_header/2"},{"type":"module","title":"Electric.Plug.ServeShapePlug","doc":"","ref":"Electric.Plug.ServeShapePlug.html"},{"type":"function","title":"Electric.Plug.ServeShapePlug.call/2","doc":"","ref":"Electric.Plug.ServeShapePlug.html#call/2"},{"type":"function","title":"Electric.Plug.ServeShapePlug.hold_until_change/2","doc":"","ref":"Electric.Plug.ServeShapePlug.html#hold_until_change/2"},{"type":"function","title":"Electric.Plug.ServeShapePlug.init/1","doc":"","ref":"Electric.Plug.ServeShapePlug.html#init/1"},{"type":"module","title":"Electric.Plug.ServeShapePlug.Params","doc":"","ref":"Electric.Plug.ServeShapePlug.Params.html"},{"type":"function","title":"Electric.Plug.ServeShapePlug.Params.cast_columns/1","doc":"","ref":"Electric.Plug.ServeShapePlug.Params.html#cast_columns/1"},{"type":"function","title":"Electric.Plug.ServeShapePlug.Params.cast_offset/1","doc":"","ref":"Electric.Plug.ServeShapePlug.Params.html#cast_offset/1"},{"type":"function","title":"Electric.Plug.ServeShapePlug.Params.cast_root_table/2","doc":"","ref":"Electric.Plug.ServeShapePlug.Params.html#cast_root_table/2"},{"type":"function","title":"Electric.Plug.ServeShapePlug.Params.validate/2","doc":"","ref":"Electric.Plug.ServeShapePlug.Params.html#validate/2"},{"type":"function","title":"Electric.Plug.ServeShapePlug.Params.validate_handle_with_offset/1","doc":"","ref":"Electric.Plug.ServeShapePlug.Params.html#validate_handle_with_offset/1"},{"type":"function","title":"Electric.Plug.ServeShapePlug.Params.validate_live_with_offset/1","doc":"","ref":"Electric.Plug.ServeShapePlug.Params.html#validate_live_with_offset/1"},{"type":"module","title":"Electric.Plug.TraceContextPlug","doc":"A plug that extracts trace context from incoming HTTP headers and sets it as the parent span.","ref":"Electric.Plug.TraceContextPlug.html"},{"type":"function","title":"Electric.Plug.TraceContextPlug.call/2","doc":"","ref":"Electric.Plug.TraceContextPlug.html#call/2"},{"type":"function","title":"Electric.Plug.TraceContextPlug.init/1","doc":"","ref":"Electric.Plug.TraceContextPlug.html#init/1"},{"type":"module","title":"Electric.Plug.UtilityRouter","doc":"","ref":"Electric.Plug.UtilityRouter.html"},{"type":"function","title":"Electric.Plug.UtilityRouter.call/2","doc":"","ref":"Electric.Plug.UtilityRouter.html#call/2"},{"type":"function","title":"Electric.Plug.UtilityRouter.init/1","doc":"","ref":"Electric.Plug.UtilityRouter.html#init/1"},{"type":"module","title":"Electric.Plug.Utils","doc":"Utility functions for Electric endpoints, e.g. for parsing and validating\npath and query parameters.","ref":"Electric.Plug.Utils.html"},{"type":"function","title":"Electric.Plug.Utils.common_open_telemetry_attrs/1","doc":"","ref":"Electric.Plug.Utils.html#common_open_telemetry_attrs/1"},{"type":"function","title":"Electric.Plug.Utils.get_next_interval_timestamp/2","doc":"Calculate the next interval that should be used for long polling based on the\ncurrent time and previous interval used.\n\nTimestamp returned is in seconds and uses a custom epoch of 9th of October 2024, UTC.","ref":"Electric.Plug.Utils.html#get_next_interval_timestamp/2"},{"type":"function","title":"Electric.Plug.Utils.hold_conn_until_stack_ready/2","doc":"","ref":"Electric.Plug.Utils.html#hold_conn_until_stack_ready/2"},{"type":"function","title":"Electric.Plug.Utils.parse_columns_param/1","doc":"Parse columns parameter from a string consisting of a comma separated list\nof potentially quoted column names into a sorted list of strings.","ref":"Electric.Plug.Utils.html#parse_columns_param/1"},{"type":"function","title":"Examples - Electric.Plug.Utils.parse_columns_param/1","doc":"iex> Electric.Plug.Utils.parse_columns_param(\"\")\n    {:error, \"Invalid zero-length delimited identifier\"}\n    iex> Electric.Plug.Utils.parse_columns_param(\"foo,\")\n    {:error, \"Invalid zero-length delimited identifier\"}\n    iex> Electric.Plug.Utils.parse_columns_param(\"id\")\n    {:ok, [\"id\"]}\n    iex> Electric.Plug.Utils.parse_columns_param(\"id,name\")\n    {:ok, [\"id\", \"name\"]}\n    iex> Electric.Plug.Utils.parse_columns_param(~S|\"PoT@To\",PoTaTo|)\n    {:ok, [\"PoT@To\", \"potato\"]}\n    iex> Electric.Plug.Utils.parse_columns_param(~S|\"PoTaTo,sunday\",foo|)\n    {:ok, [\"PoTaTo,sunday\", \"foo\"]}\n    iex> Electric.Plug.Utils.parse_columns_param(~S|\"fo\"\"o\",bar|)\n    {:ok, [~S|fo\"o|, \"bar\"]}\n    iex> Electric.Plug.Utils.parse_columns_param(~S|\"id,\"name\"|)\n    {:error, ~S|Invalid unquoted identifier contains special characters: \"id|}","ref":"Electric.Plug.Utils.html#parse_columns_param/1-examples"},{"type":"module","title":"Electric.Plug.Utils.CORSHeaderPlug","doc":"","ref":"Electric.Plug.Utils.CORSHeaderPlug.html"},{"type":"function","title":"Electric.Plug.Utils.CORSHeaderPlug.call/2","doc":"","ref":"Electric.Plug.Utils.CORSHeaderPlug.html#call/2"},{"type":"function","title":"Electric.Plug.Utils.CORSHeaderPlug.init/1","doc":"","ref":"Electric.Plug.Utils.CORSHeaderPlug.html#init/1"},{"type":"module","title":"Electric.Plug.Utils.PassAssignToOptsPlug","doc":"","ref":"Electric.Plug.Utils.PassAssignToOptsPlug.html"},{"type":"function","title":"Electric.Plug.Utils.PassAssignToOptsPlug.call/2","doc":"","ref":"Electric.Plug.Utils.PassAssignToOptsPlug.html#call/2"},{"type":"function","title":"Electric.Plug.Utils.PassAssignToOptsPlug.init/1","doc":"","ref":"Electric.Plug.Utils.PassAssignToOptsPlug.html#init/1"},{"type":"module","title":"Electric.Postgres","doc":"","ref":"Electric.Postgres.html"},{"type":"function","title":"Electric.Postgres.display_settings/0","doc":"Configuration settings that affect formatting of values of certain types.\n\nThese settings should be set for the current session before executing any queries or\nstatements to safe-guard against non-standard configuration being used in the Postgres\ndatabase cluster or even the specific database Electric is configured to connect to.\n\nThe settings Electric is sensitive to are:\n\n  * `bytea_output`       - determines how Postgres encodes bytea values. It can use either Hex- or\n                           Escape-based encoding.\n\n  * `DateStyle`          - determines how Postgres interprets date values.\n\n  * `TimeZone`           - affects the time zone offset Postgres uses for timestamptz and timetz values.\n\n  * `extra_float_digits` - determines whether floating-point values are rounded or are encoded precisely.\n\n  * `IntervalStyle`      - determines how Postgres interprets and formats interval values.","ref":"Electric.Postgres.html#display_settings/0"},{"type":"function","title":"Electric.Postgres.supported_types/0","doc":"All types currently supported by Electric","ref":"Electric.Postgres.html#supported_types/0"},{"type":"function","title":"Tests - Electric.Postgres.supported_types/0","doc":"iex> :bool in supported_types()\n    true","ref":"Electric.Postgres.html#supported_types/0-tests"},{"type":"function","title":"Electric.Postgres.supported_types_only_in_functions/0","doc":"All types currently supported by Electric only in functions","ref":"Electric.Postgres.html#supported_types_only_in_functions/0"},{"type":"function","title":"Tests - Electric.Postgres.supported_types_only_in_functions/0","doc":"iex> :interval in supported_types_only_in_functions()\n    true","ref":"Electric.Postgres.html#supported_types_only_in_functions/0-tests"},{"type":"module","title":"Electric.Postgres.Configuration","doc":"Module for functions that configure Postgres in some way using\na provided connection.","ref":"Electric.Postgres.Configuration.html"},{"type":"function","title":"Electric.Postgres.Configuration.configure_tables_for_replication!/4","doc":"Ensure that all tables are configured for replication.\n\nTable is considered configured for replication when it's `REPLICA IDENTITY` is set to `FULL`\nand it's added to the specified publication.\n\nImportant: this function should not be ran in a transaction, because it starts multiple\ninternal transactions that are sometimes expected to fail.\n\nRaises if it fails to configure all the tables in the expected way.","ref":"Electric.Postgres.Configuration.html#configure_tables_for_replication!/4"},{"type":"function","title":"Electric.Postgres.Configuration.drop_all_publication_tables/2","doc":"Drops all tables from the given publication.","ref":"Electric.Postgres.Configuration.html#drop_all_publication_tables/2"},{"type":"type","title":"Electric.Postgres.Configuration.filter/0","doc":"","ref":"Electric.Postgres.Configuration.html#t:filter/0"},{"type":"type","title":"Electric.Postgres.Configuration.filters/0","doc":"","ref":"Electric.Postgres.Configuration.html#t:filters/0"},{"type":"module","title":"Electric.Postgres.Identifiers","doc":"","ref":"Electric.Postgres.Identifiers.html"},{"type":"function","title":"Electric.Postgres.Identifiers.downcase/3","doc":"Downcase the identifier and truncate if necessary, using\nPostgreSQL's algorithm for downcasing.\n\nSetting `truncate` to `true` will truncate the identifier to 63 characters\n\nSetting `single_byte_encoding` to `true` will downcase the identifier\nusing single byte encoding\n\nSee:\nhttps://github.com/postgres/postgres/blob/259a0a99fe3d45dcf624788c1724d9989f3382dc/src/backend/parser/scansup.c#L46-L80","ref":"Electric.Postgres.Identifiers.html#downcase/3"},{"type":"function","title":"Examples - Electric.Postgres.Identifiers.downcase/3","doc":"iex> Electric.Postgres.Identifiers.downcase(\"FooBar\")\n    \"foobar\"\n    iex> Electric.Postgres.Identifiers.downcase(String.duplicate(\"a\", 100), true)\n    String.duplicate(\"a\", 63)","ref":"Electric.Postgres.Identifiers.html#downcase/3-examples"},{"type":"function","title":"Electric.Postgres.Identifiers.parse/3","doc":"Parse a PostgreSQL identifier, removing quotes if present and escaping internal ones\nand downcasing the identifier otherwise.","ref":"Electric.Postgres.Identifiers.html#parse/3"},{"type":"function","title":"Examples - Electric.Postgres.Identifiers.parse/3","doc":"iex> Electric.Postgres.Identifiers.parse(\"FooBar\")\n    {:ok, \"foobar\"}\n\n    iex> Electric.Postgres.Identifiers.parse(~S|\"FooBar\"|)\n    {:ok, \"FooBar\"}\n\n    iex> Electric.Postgres.Identifiers.parse(~S|Foo\"Bar\"|)\n    {:error, ~S|Invalid unquoted identifier contains special characters: Foo\"Bar\"|}\n\n    iex> Electric.Postgres.Identifiers.parse(~S| |)\n    {:error, ~S|Invalid unquoted identifier contains special characters:  |}\n\n    iex> Electric.Postgres.Identifiers.parse(\"foob@r\")\n    {:error, ~S|Invalid unquoted identifier contains special characters: foob@r|}\n\n    iex> Electric.Postgres.Identifiers.parse(~S|\"Foo\"Bar\"|)\n    {:error, ~S|Invalid identifier with unescaped quote: Foo\"Bar|}\n\n    iex> Electric.Postgres.Identifiers.parse(~S|\"\"|)\n    {:error, \"Invalid zero-length delimited identifier\"}\n\n    iex> Electric.Postgres.Identifiers.parse(\"\")\n    {:error, \"Invalid zero-length delimited identifier\"}\n\n    iex> Electric.Postgres.Identifiers.parse(~S|\" \"|)\n    {:ok, \" \"}\n\n    iex> Electric.Postgres.Identifiers.parse(~S|\"Foo\"\"Bar\"|)\n    {:ok, ~S|Foo\"Bar|}","ref":"Electric.Postgres.Identifiers.html#parse/3-examples"},{"type":"function","title":"Electric.Postgres.Identifiers.parse_relation/1","doc":"Parse a PostgreSQL relation identifier","ref":"Electric.Postgres.Identifiers.html#parse_relation/1"},{"type":"function","title":"Examples - Electric.Postgres.Identifiers.parse_relation/1","doc":"iex> Electric.Postgres.Identifiers.parse_relation(\"foo\")\n    {:ok, {\"public\", \"foo\"}}\n\n    iex> Electric.Postgres.Identifiers.parse_relation(\"foo.bar\")\n    {:ok, {\"foo\", \"bar\"}}\n\n    iex> Electric.Postgres.Identifiers.parse_relation(~S|\"foo\".\"bar\"|)\n    {:ok, {\"foo\", \"bar\"}}\n\n    iex> Electric.Postgres.Identifiers.parse_relation(~S|\"foo.woah\".\"bar\"|)\n    {:ok, {\"foo.woah\", \"bar\"}}\n\n    iex> Electric.Postgres.Identifiers.parse_relation(~S|\"foo\".bar|)\n    {:ok, {\"foo\", \"bar\"}}\n\n    iex> Electric.Postgres.Identifiers.parse_relation(~S|\"foo\".\"bar|)\n    {:error, ~S|Invalid unquoted identifier contains special characters: \"bar|}\n\n    iex> Electric.Postgres.Identifiers.parse_relation(\"foo.bar.baz\")\n    {:error, \"Invalid relation identifier, too many delimiters: foo.bar.baz\"}","ref":"Electric.Postgres.Identifiers.html#parse_relation/1-examples"},{"type":"function","title":"Electric.Postgres.Identifiers.parse_unquoted_identifier/3","doc":"Parse an unquoted PostgreSQL identifier, downcasing characters and failing if any\nspecial characters are present","ref":"Electric.Postgres.Identifiers.html#parse_unquoted_identifier/3"},{"type":"function","title":"Examples - Electric.Postgres.Identifiers.parse_unquoted_identifier/3","doc":"iex> Electric.Postgres.Identifiers.parse_unquoted_identifier(\"FooBar\")\n    {:ok, \"foobar\"}\n\n    iex> Electric.Postgres.Identifiers.parse_unquoted_identifier(\"foob@r\")\n    {:error, ~S|Invalid unquoted identifier contains special characters: foob@r|}","ref":"Electric.Postgres.Identifiers.html#parse_unquoted_identifier/3-examples"},{"type":"module","title":"Electric.Postgres.Identifiers.StringSplitter","doc":"Utility module for splitting strings on a schema delimiter","ref":"Electric.Postgres.Identifiers.StringSplitter.html"},{"type":"function","title":"Electric.Postgres.Identifiers.StringSplitter.split_outside_quotes/1","doc":"Split a string on a schema delimiter, only if the delimiter is not\ninside quotes, returning a list of strings","ref":"Electric.Postgres.Identifiers.StringSplitter.html#split_outside_quotes/1"},{"type":"behaviour","title":"Electric.Postgres.Inspector","doc":"","ref":"Electric.Postgres.Inspector.html"},{"type":"function","title":"Electric.Postgres.Inspector.clean/2","doc":"Clean up all information about a given relation using a provided inspector.","ref":"Electric.Postgres.Inspector.html#clean/2"},{"type":"callback","title":"Electric.Postgres.Inspector.clean/2","doc":"","ref":"Electric.Postgres.Inspector.html#c:clean/2"},{"type":"function","title":"Electric.Postgres.Inspector.columns_to_expr/1","doc":"Convert a column list into something that can be used by\n`Electric.Replication.Eval.Parser.parse_and_validate_expression/2`","ref":"Electric.Postgres.Inspector.html#columns_to_expr/1"},{"type":"function","title":"Electric.Postgres.Inspector.get_pk_cols/1","doc":"Get columns that should be considered a PK for table. If the table\nhas no PK, then we're considering all columns as identifying.","ref":"Electric.Postgres.Inspector.html#get_pk_cols/1"},{"type":"function","title":"Electric.Postgres.Inspector.load_column_info/2","doc":"Load column information about a given table using a provided inspector.","ref":"Electric.Postgres.Inspector.html#load_column_info/2"},{"type":"callback","title":"Electric.Postgres.Inspector.load_column_info/2","doc":"","ref":"Electric.Postgres.Inspector.html#c:load_column_info/2"},{"type":"function","title":"Electric.Postgres.Inspector.load_relation/2","doc":"Expects the table name provided by the user\nand validates that the table exists and returns the relation.\n\nThe table name can be quoted or unquoted and can optionally be qualified,\ne.g. `users` would return `{\"public\", \"users\"}`,\n     `usErs` would return `{\"public\", \"users\"}`,\n     `\"Users\"` would return `{\"public\", \"Users\"}`,\n     `some_schema.users` would return `{\"some_schema\", \"users\"}`.","ref":"Electric.Postgres.Inspector.html#load_relation/2"},{"type":"callback","title":"Electric.Postgres.Inspector.load_relation/2","doc":"","ref":"Electric.Postgres.Inspector.html#c:load_relation/2"},{"type":"type","title":"Electric.Postgres.Inspector.column_info/0","doc":"","ref":"Electric.Postgres.Inspector.html#t:column_info/0"},{"type":"type","title":"Electric.Postgres.Inspector.inspector/0","doc":"","ref":"Electric.Postgres.Inspector.html#t:inspector/0"},{"type":"type","title":"Electric.Postgres.Inspector.relation/0","doc":"","ref":"Electric.Postgres.Inspector.html#t:relation/0"},{"type":"type","title":"Electric.Postgres.Inspector.relation_id/0","doc":"","ref":"Electric.Postgres.Inspector.html#t:relation_id/0"},{"type":"type","title":"Electric.Postgres.Inspector.relation_info/0","doc":"","ref":"Electric.Postgres.Inspector.html#t:relation_info/0"},{"type":"module","title":"Electric.Postgres.Inspector.DirectInspector","doc":"","ref":"Electric.Postgres.Inspector.DirectInspector.html"},{"type":"function","title":"Electric.Postgres.Inspector.DirectInspector.clean/2","doc":"","ref":"Electric.Postgres.Inspector.DirectInspector.html#clean/2"},{"type":"function","title":"Electric.Postgres.Inspector.DirectInspector.load_column_info/2","doc":"Load table information (refs) from the database","ref":"Electric.Postgres.Inspector.DirectInspector.html#load_column_info/2"},{"type":"function","title":"Electric.Postgres.Inspector.DirectInspector.load_relation/2","doc":"Returns the PG relation from the table name.","ref":"Electric.Postgres.Inspector.DirectInspector.html#load_relation/2"},{"type":"module","title":"Electric.Postgres.Inspector.EtsInspector","doc":"","ref":"Electric.Postgres.Inspector.EtsInspector.html"},{"type":"function","title":"Electric.Postgres.Inspector.EtsInspector.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Electric.Postgres.Inspector.EtsInspector.html#child_spec/1"},{"type":"function","title":"Electric.Postgres.Inspector.EtsInspector.get_column_info_table/1","doc":"","ref":"Electric.Postgres.Inspector.EtsInspector.html#get_column_info_table/1"},{"type":"function","title":"Electric.Postgres.Inspector.EtsInspector.get_relation_table/1","doc":"","ref":"Electric.Postgres.Inspector.EtsInspector.html#get_relation_table/1"},{"type":"function","title":"Electric.Postgres.Inspector.EtsInspector.name/1","doc":"","ref":"Electric.Postgres.Inspector.EtsInspector.html#name/1"},{"type":"function","title":"Electric.Postgres.Inspector.EtsInspector.start_link/1","doc":"","ref":"Electric.Postgres.Inspector.EtsInspector.html#start_link/1"},{"type":"module","title":"Electric.Postgres.LockConnection","doc":"A Postgres connection that ensures an advisory lock is held for its entire duration,\nuseful for ensuring only a single sync service instance can be using a single\nreplication slot at any given time.\n\nThe connection attempts to grab the lock and waits on it until it acquires it.\nWhen it does, it fires off an :exclusive_connection_lock_acquired message to the specified\n`Electric.Connection.Manager` such that the required setup can acquired now that\nthe service is sure to be the only one operating on this replication stream.","ref":"Electric.Postgres.LockConnection.html"},{"type":"function","title":"Electric.Postgres.LockConnection.start_link/1","doc":"","ref":"Electric.Postgres.LockConnection.html#start_link/1"},{"type":"type","title":"Electric.Postgres.LockConnection.option/0","doc":"","ref":"Electric.Postgres.LockConnection.html#t:option/0"},{"type":"type","title":"Electric.Postgres.LockConnection.options/0","doc":"","ref":"Electric.Postgres.LockConnection.html#t:options/0"},{"type":"module","title":"Electric.Postgres.LockConnection.State","doc":"","ref":"Electric.Postgres.LockConnection.State.html"},{"type":"module","title":"Electric.Postgres.LogicalReplication.Messages","doc":"","ref":"Electric.Postgres.LogicalReplication.Messages.html"},{"type":"type","title":"Electric.Postgres.LogicalReplication.Messages.message/0","doc":"","ref":"Electric.Postgres.LogicalReplication.Messages.html#t:message/0"},{"type":"type","title":"Electric.Postgres.LogicalReplication.Messages.relation_id/0","doc":"","ref":"Electric.Postgres.LogicalReplication.Messages.html#t:relation_id/0"},{"type":"module","title":"Electric.Postgres.LogicalReplication.Messages.Begin","doc":"","ref":"Electric.Postgres.LogicalReplication.Messages.Begin.html"},{"type":"type","title":"Electric.Postgres.LogicalReplication.Messages.Begin.t/0","doc":"","ref":"Electric.Postgres.LogicalReplication.Messages.Begin.html#t:t/0"},{"type":"module","title":"Electric.Postgres.LogicalReplication.Messages.Commit","doc":"","ref":"Electric.Postgres.LogicalReplication.Messages.Commit.html"},{"type":"type","title":"Electric.Postgres.LogicalReplication.Messages.Commit.t/0","doc":"","ref":"Electric.Postgres.LogicalReplication.Messages.Commit.html#t:t/0"},{"type":"module","title":"Electric.Postgres.LogicalReplication.Messages.Delete","doc":"","ref":"Electric.Postgres.LogicalReplication.Messages.Delete.html"},{"type":"type","title":"Electric.Postgres.LogicalReplication.Messages.Delete.t/0","doc":"","ref":"Electric.Postgres.LogicalReplication.Messages.Delete.html#t:t/0"},{"type":"module","title":"Electric.Postgres.LogicalReplication.Messages.Insert","doc":"","ref":"Electric.Postgres.LogicalReplication.Messages.Insert.html"},{"type":"type","title":"Electric.Postgres.LogicalReplication.Messages.Insert.t/0","doc":"","ref":"Electric.Postgres.LogicalReplication.Messages.Insert.html#t:t/0"},{"type":"module","title":"Electric.Postgres.LogicalReplication.Messages.Message","doc":"","ref":"Electric.Postgres.LogicalReplication.Messages.Message.html"},{"type":"type","title":"Electric.Postgres.LogicalReplication.Messages.Message.t/0","doc":"","ref":"Electric.Postgres.LogicalReplication.Messages.Message.html#t:t/0"},{"type":"module","title":"Electric.Postgres.LogicalReplication.Messages.Origin","doc":"","ref":"Electric.Postgres.LogicalReplication.Messages.Origin.html"},{"type":"type","title":"Electric.Postgres.LogicalReplication.Messages.Origin.t/0","doc":"","ref":"Electric.Postgres.LogicalReplication.Messages.Origin.html#t:t/0"},{"type":"module","title":"Electric.Postgres.LogicalReplication.Messages.Relation","doc":"","ref":"Electric.Postgres.LogicalReplication.Messages.Relation.html"},{"type":"type","title":"Electric.Postgres.LogicalReplication.Messages.Relation.t/0","doc":"","ref":"Electric.Postgres.LogicalReplication.Messages.Relation.html#t:t/0"},{"type":"module","title":"Electric.Postgres.LogicalReplication.Messages.Relation.Column","doc":"","ref":"Electric.Postgres.LogicalReplication.Messages.Relation.Column.html"},{"type":"type","title":"Electric.Postgres.LogicalReplication.Messages.Relation.Column.t/0","doc":"","ref":"Electric.Postgres.LogicalReplication.Messages.Relation.Column.html#t:t/0"},{"type":"module","title":"Electric.Postgres.LogicalReplication.Messages.Truncate","doc":"","ref":"Electric.Postgres.LogicalReplication.Messages.Truncate.html"},{"type":"type","title":"Electric.Postgres.LogicalReplication.Messages.Truncate.t/0","doc":"","ref":"Electric.Postgres.LogicalReplication.Messages.Truncate.html#t:t/0"},{"type":"module","title":"Electric.Postgres.LogicalReplication.Messages.Type","doc":"","ref":"Electric.Postgres.LogicalReplication.Messages.Type.html"},{"type":"type","title":"Electric.Postgres.LogicalReplication.Messages.Type.t/0","doc":"","ref":"Electric.Postgres.LogicalReplication.Messages.Type.html#t:t/0"},{"type":"module","title":"Electric.Postgres.LogicalReplication.Messages.Unsupported","doc":"","ref":"Electric.Postgres.LogicalReplication.Messages.Unsupported.html"},{"type":"type","title":"Electric.Postgres.LogicalReplication.Messages.Unsupported.t/0","doc":"","ref":"Electric.Postgres.LogicalReplication.Messages.Unsupported.html#t:t/0"},{"type":"module","title":"Electric.Postgres.LogicalReplication.Messages.Update","doc":"","ref":"Electric.Postgres.LogicalReplication.Messages.Update.html"},{"type":"type","title":"Electric.Postgres.LogicalReplication.Messages.Update.t/0","doc":"","ref":"Electric.Postgres.LogicalReplication.Messages.Update.html#t:t/0"},{"type":"module","title":"Electric.Postgres.Lsn","doc":"Encoding, decoding and helper functions for the pg_lsn type.","ref":"Electric.Postgres.Lsn.html"},{"type":"function","title":"Electric.Postgres.Lsn.compare/2","doc":"Compare two Lsns and determine if one is less or greater or both are equal.","ref":"Electric.Postgres.Lsn.html#compare/2"},{"type":"function","title":"Examples - Electric.Postgres.Lsn.compare/2","doc":"iex> compare(from_integer(0), from_integer(1))\n    :lt\n    iex> compare(from_string(\"1/0\"), from_string(\"2/0\"))\n    :lt\n\n    iex> compare(from_integer(99), from_integer(98))\n    :gt\n    iex> compare(from_string(\"2/0\"), from_string(\"1/0\"))\n    :gt\n\n    iex> compare(from_integer(127_000_256), from_string(\"0/791DEC0\"))\n    :eq","ref":"Electric.Postgres.Lsn.html#compare/2-examples"},{"type":"function","title":"Electric.Postgres.Lsn.decode_bin/1","doc":"Decode a binary representation of the LSN into a struct. Reverses `encode_bin/1`","ref":"Electric.Postgres.Lsn.html#decode_bin/1"},{"type":"function","title":"Examples - Electric.Postgres.Lsn.decode_bin/1","doc":"iex> decode_bin(encode_bin(%Elixir.Electric.Postgres.Lsn{}))\n    %Elixir.Electric.Postgres.Lsn{}","ref":"Electric.Postgres.Lsn.html#decode_bin/1-examples"},{"type":"function","title":"Electric.Postgres.Lsn.encode_bin/1","doc":"","ref":"Electric.Postgres.Lsn.html#encode_bin/1"},{"type":"function","title":"Electric.Postgres.Lsn.from_integer/1","doc":"Convert the non-negative byte offset into Lsn.","ref":"Electric.Postgres.Lsn.html#from_integer/1"},{"type":"function","title":"Examples - Electric.Postgres.Lsn.from_integer/1","doc":"iex> from_integer(0)\n    %Elixir.Electric.Postgres.Lsn{segment: 0, offset: 0}\n\n    iex> from_integer(1_000_000)\n    %Elixir.Electric.Postgres.Lsn{segment: 0, offset: 1_000_000}\n\n    iex> from_integer(0xFFFFFFFF)\n    %Elixir.Electric.Postgres.Lsn{segment: 0, offset: 4294967295}\n\n    iex> from_integer(0xFFFFFFFFF)\n    %Elixir.Electric.Postgres.Lsn{segment: 15, offset: 4294967295}\n\n    iex> from_integer(-1)\n    ** (FunctionClauseError) no function clause matching in Electric.Postgres.Lsn.from_integer/1","ref":"Electric.Postgres.Lsn.html#from_integer/1-examples"},{"type":"function","title":"Electric.Postgres.Lsn.from_string/1","doc":"Parse the given string as a pg_lsn value.","ref":"Electric.Postgres.Lsn.html#from_string/1"},{"type":"function","title":"Examples - Electric.Postgres.Lsn.from_string/1","doc":"iex> from_string(\"0/0\")\n    %Elixir.Electric.Postgres.Lsn{segment: 0, offset: 0}\n\n    iex> from_string(\"7F/400\")\n    %Elixir.Electric.Postgres.Lsn{segment: 127, offset: 1024}","ref":"Electric.Postgres.Lsn.html#from_string/1-examples"},{"type":"function","title":"Electric.Postgres.Lsn.increment/2","doc":"Add the given byte offset to the Lsn value.\n\nThe result is capped at the bottom to not go below #Lsn<0/0>.","ref":"Electric.Postgres.Lsn.html#increment/2"},{"type":"function","title":"Examples - Electric.Postgres.Lsn.increment/2","doc":"iex> increment(from_integer(0), 8_000_000)\n    %Elixir.Electric.Postgres.Lsn{segment: 0, offset: 8_000_000}\n\n    iex> increment(from_integer(4_000_000_000), 1_000_000_000)\n    %Elixir.Electric.Postgres.Lsn{segment: 1, offset: 705_032_704}\n\n    iex> to_integer(%Elixir.Electric.Postgres.Lsn{segment: 1, offset: 705_032_704})\n    5_000_000_000\n\n    iex> increment(from_integer(4_000_000_000), 10_000_000_000)\n    %Elixir.Electric.Postgres.Lsn{segment: 3, offset: 1_115_098_112}\n\n    iex> to_integer(%Elixir.Electric.Postgres.Lsn{segment: 3, offset: 1_115_098_112})\n    14_000_000_000\n\n    iex> increment(from_integer(14_000_000_000), -8_000_000_000)\n    %Elixir.Electric.Postgres.Lsn{segment: 1, offset: 1_705_032_704}\n\n    iex> increment(from_integer(100), -99)\n    %Elixir.Electric.Postgres.Lsn{segment: 0, offset: 1}\n\n    iex> increment(from_integer(100), -100)\n    %Elixir.Electric.Postgres.Lsn{segment: 0, offset: 0}\n\n    iex> increment(from_integer(100), -101)\n    %Elixir.Electric.Postgres.Lsn{segment: 0, offset: 0}","ref":"Electric.Postgres.Lsn.html#increment/2-examples"},{"type":"function","title":"Electric.Postgres.Lsn.to_integer/1","doc":"Convert the Lsn into an equivalent byte offset.","ref":"Electric.Postgres.Lsn.html#to_integer/1"},{"type":"function","title":"Examples - Electric.Postgres.Lsn.to_integer/1","doc":"iex> to_integer(%Elixir.Electric.Postgres.Lsn{segment: 0, offset: 0})\n    0\n\n    iex> to_integer(%Elixir.Electric.Postgres.Lsn{segment: 0, offset: 1_000_000})\n    1_000_000\n\n    iex> to_integer(%Elixir.Electric.Postgres.Lsn{segment: 0, offset: 4294967295})\n    0xFFFFFFFF\n\n    iex> to_integer(%Elixir.Electric.Postgres.Lsn{segment: 15, offset: 4294967295})\n    0xFFFFFFFFF","ref":"Electric.Postgres.Lsn.html#to_integer/1-examples"},{"type":"function","title":"Electric.Postgres.Lsn.to_iolist/1","doc":"Format Lsn to its text representation in an iolist.","ref":"Electric.Postgres.Lsn.html#to_iolist/1"},{"type":"function","title":"Examples - Electric.Postgres.Lsn.to_iolist/1","doc":"iex> to_iolist(%Elixir.Electric.Postgres.Lsn{})\n    [\"0\", ?/, \"0\"]\n\n    iex> to_iolist(%Elixir.Electric.Postgres.Lsn{segment: 127, offset: 1024})\n    [\"7F\", ?/, \"400\"]","ref":"Electric.Postgres.Lsn.html#to_iolist/1-examples"},{"type":"type","title":"Electric.Postgres.Lsn.int32/0","doc":"","ref":"Electric.Postgres.Lsn.html#t:int32/0"},{"type":"type","title":"Electric.Postgres.Lsn.t/0","doc":"","ref":"Electric.Postgres.Lsn.html#t:t/0"},{"type":"module","title":"Electric.Postgres.ReplicationClient","doc":"A client module for Postgres logical replication.","ref":"Electric.Postgres.ReplicationClient.html"},{"type":"function","title":"Electric.Postgres.ReplicationClient.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Electric.Postgres.ReplicationClient.html#child_spec/1"},{"type":"function","title":"Electric.Postgres.ReplicationClient.name/1","doc":"","ref":"Electric.Postgres.ReplicationClient.html#name/1"},{"type":"function","title":"Electric.Postgres.ReplicationClient.start_link/1","doc":"","ref":"Electric.Postgres.ReplicationClient.html#start_link/1"},{"type":"function","title":"Electric.Postgres.ReplicationClient.start_streaming/1","doc":"","ref":"Electric.Postgres.ReplicationClient.html#start_streaming/1"},{"type":"function","title":"Electric.Postgres.ReplicationClient.stop/2","doc":"","ref":"Electric.Postgres.ReplicationClient.html#stop/2"},{"type":"type","title":"Electric.Postgres.ReplicationClient.step/0","doc":"","ref":"Electric.Postgres.ReplicationClient.html#t:step/0"},{"type":"module","title":"Electric.Postgres.ReplicationClient.Collector","doc":"Conversion of incoming Postgres logical replication messages\nto internal change representation.","ref":"Electric.Postgres.ReplicationClient.Collector.html"},{"type":"function","title":"Electric.Postgres.ReplicationClient.Collector.handle_message/2","doc":"Handle incoming logical replication message by either building up a transaction or\nreturning a complete built up transaction.","ref":"Electric.Postgres.ReplicationClient.Collector.html#handle_message/2"},{"type":"type","title":"Electric.Postgres.ReplicationClient.Collector.t/0","doc":"","ref":"Electric.Postgres.ReplicationClient.Collector.html#t:t/0"},{"type":"module","title":"Electric.Postgres.ReplicationClient.ConnectionSetup","doc":"This module encapsulates the initial setup of a replication connection opened by\n`Electric.Postgres.ReplicationClient`.\n\nA state machine is implemented to run a series of SQL queries prior to switching the\nconnection into the logical streaming mode. This helps keep the main `ReplicationClient`\nmodule focused on the handling of logical messages.","ref":"Electric.Postgres.ReplicationClient.ConnectionSetup.html"},{"type":"function","title":"Electric.Postgres.ReplicationClient.ConnectionSetup.process_query_result/2","doc":"","ref":"Electric.Postgres.ReplicationClient.ConnectionSetup.html#process_query_result/2"},{"type":"function","title":"Electric.Postgres.ReplicationClient.ConnectionSetup.start/1","doc":"","ref":"Electric.Postgres.ReplicationClient.ConnectionSetup.html#start/1"},{"type":"function","title":"Electric.Postgres.ReplicationClient.ConnectionSetup.start_streaming/1","doc":"","ref":"Electric.Postgres.ReplicationClient.ConnectionSetup.html#start_streaming/1"},{"type":"type","title":"Electric.Postgres.ReplicationClient.ConnectionSetup.callback_return/0","doc":"","ref":"Electric.Postgres.ReplicationClient.ConnectionSetup.html#t:callback_return/0"},{"type":"type","title":"Electric.Postgres.ReplicationClient.ConnectionSetup.query_result/0","doc":"","ref":"Electric.Postgres.ReplicationClient.ConnectionSetup.html#t:query_result/0"},{"type":"type","title":"Electric.Postgres.ReplicationClient.ConnectionSetup.state/0","doc":"","ref":"Electric.Postgres.ReplicationClient.ConnectionSetup.html#t:state/0"},{"type":"type","title":"Electric.Postgres.ReplicationClient.ConnectionSetup.step/0","doc":"","ref":"Electric.Postgres.ReplicationClient.ConnectionSetup.html#t:step/0"},{"type":"module","title":"Electric.Postgres.ReplicationClient.State","doc":"","ref":"Electric.Postgres.ReplicationClient.State.html"},{"type":"function","title":"Electric.Postgres.ReplicationClient.State.new/1","doc":"","ref":"Electric.Postgres.ReplicationClient.State.html#new/1"},{"type":"type","title":"Electric.Postgres.ReplicationClient.State.t/0","doc":"","ref":"Electric.Postgres.ReplicationClient.State.html#t:t/0"},{"type":"module","title":"Electric.ProcessRegistry","doc":"","ref":"Electric.ProcessRegistry.html"},{"type":"function","title":"Electric.ProcessRegistry.alive?/3","doc":"","ref":"Electric.ProcessRegistry.html#alive?/3"},{"type":"function","title":"Electric.ProcessRegistry.child_spec/1","doc":"","ref":"Electric.ProcessRegistry.html#child_spec/1"},{"type":"function","title":"Electric.ProcessRegistry.name/3","doc":"","ref":"Electric.ProcessRegistry.html#name/3"},{"type":"function","title":"Electric.ProcessRegistry.registry_name/1","doc":"","ref":"Electric.ProcessRegistry.html#registry_name/1"},{"type":"function","title":"Electric.ProcessRegistry.start_link/1","doc":"","ref":"Electric.ProcessRegistry.html#start_link/1"},{"type":"module","title":"Electric.Replication.Changes","doc":"This module contains structs that are intermediate representation of Postgres and Satellite transactions.\n\nSome of the core assumptions in this module:\n- We require PK always to be present for all tables\n- For now PK modification is not supported\n- PG replication protocol is expected to always send the *whole* row\nwhen dealing with UPDATE changes, and optionally old row if REPLICA\nidentity is set to FULL.","ref":"Electric.Replication.Changes.html"},{"type":"function","title":"Electric.Replication.Changes.build_key/3","doc":"Build a unique key for a given record based on it's relation and PK.\n\nUses the `/` symbol as a PK separator, so any `/`s in the PK will\nbe escaped to avoid collisions.","ref":"Electric.Replication.Changes.html#build_key/3"},{"type":"function","title":"Examples - Electric.Replication.Changes.build_key/3","doc":"Build key respects PK column order:\n\n    iex> build_key({\"hello\", \"world\"}, %{\"c\" => \"d\", \"a\" => \"b\"}, [\"a\", \"c\"])\n    ~S|\"hello\".\"world\"/\"b\"/\"d\"|\n    iex> build_key({\"hello\", \"world\"}, %{\"a\" => \"b\", \"c\" => \"d\"}, [\"a\", \"c\"])\n    ~S|\"hello\".\"world\"/\"b\"/\"d\"|\n\nBuild key has `/` symbol in the PK escaped by repetition:\n\n    iex> build_key({\"hello\", \"world\"}, %{\"a\" => \"test/test\", \"c\" => \"test\"}, [\"a\", \"c\"])\n    ~S|\"hello\".\"world\"/\"test//test\"/\"test\"|\n    iex> build_key({\"hello\", \"world\"}, %{\"a\" => \"test\", \"c\" => \"test/test\"}, [\"a\", \"c\"])\n    ~S|\"hello\".\"world\"/\"test\"/\"test//test\"|\n\nIf a table has no PK, all columns are used, sorted by the column name:\n\n    iex> build_key({\"hello\", \"world\"}, %{\"c\" => \"d\", \"a\" => \"b\"}, [])\n    ~S|\"hello\".\"world\"/\"b\"/\"d\"|\n\nAll pk sections are wrapped in quotes to allow for empty strings without generating a `//` pair.\n\n    iex> build_key({\"hello\", \"world\"}, %{\"a\" => \"1\", \"b\" => \"\", \"c\" => \"2\"}, [])\n    ~S|\"hello\".\"world\"/\"1\"/\"\"/\"2\"|","ref":"Electric.Replication.Changes.html#build_key/3-examples"},{"type":"function","title":"Electric.Replication.Changes.convert_update/2","doc":"Convert an UpdatedRecord into the corresponding NewRecord or DeletedRecord\nbased on the provided `to` option.","ref":"Electric.Replication.Changes.html#convert_update/2"},{"type":"function","title":"Examples - Electric.Replication.Changes.convert_update/2","doc":"iex> convert_update(%UpdatedRecord{record: %{id: 1}}, to: :new_record)\n    %NewRecord{record: %{id: 1}}\n\n    iex> convert_update(%UpdatedRecord{record: %{id: 2}, old_record: %{id: 1}}, to: :deleted_record)\n    %DeletedRecord{old_record: %{id: 1}}\n\n    iex> convert_update(%UpdatedRecord{record: %{id: 1}}, to: :updated_record)\n    %UpdatedRecord{record: %{id: 1}}","ref":"Electric.Replication.Changes.html#convert_update/2-examples"},{"type":"function","title":"Electric.Replication.Changes.fill_key/2","doc":"","ref":"Electric.Replication.Changes.html#fill_key/2"},{"type":"function","title":"Electric.Replication.Changes.filter_columns/2","doc":"Filter the columns of a change to include only those provided in `columns_to_keep`.","ref":"Electric.Replication.Changes.html#filter_columns/2"},{"type":"function","title":"Examples - Electric.Replication.Changes.filter_columns/2","doc":"iex> filter_columns(%NewRecord{record: %{\"a\" => \"b\", \"c\" => \"d\"}}, [\"a\"])\n    %NewRecord{record: %{\"a\" => \"b\"}}\n\n    iex> filter_columns(UpdatedRecord.new(\n    ...>  record: %{\"a\" => \"b\", \"c\" => \"d\"},\n    ...>  old_record: %{\"a\" => \"d\", \"c\" => \"f\"}\n    ...>  ), [\"a\"])\n    UpdatedRecord.new(record: %{\"a\" => \"b\"}, old_record: %{\"a\" => \"d\"})\n\n    iex> filter_columns(%DeletedRecord{old_record: %{\"a\" => \"b\", \"c\" => \"d\"}}, [\"c\"])\n    %DeletedRecord{old_record: %{\"c\" => \"d\"}}","ref":"Electric.Replication.Changes.html#filter_columns/2-examples"},{"type":"type","title":"Electric.Replication.Changes.change/0","doc":"","ref":"Electric.Replication.Changes.html#t:change/0"},{"type":"type","title":"Electric.Replication.Changes.data_change/0","doc":"","ref":"Electric.Replication.Changes.html#t:data_change/0"},{"type":"type","title":"Electric.Replication.Changes.db_identifier/0","doc":"","ref":"Electric.Replication.Changes.html#t:db_identifier/0"},{"type":"type","title":"Electric.Replication.Changes.pk/0","doc":"","ref":"Electric.Replication.Changes.html#t:pk/0"},{"type":"type","title":"Electric.Replication.Changes.record/0","doc":"","ref":"Electric.Replication.Changes.html#t:record/0"},{"type":"type","title":"Electric.Replication.Changes.relation_id/0","doc":"","ref":"Electric.Replication.Changes.html#t:relation_id/0"},{"type":"type","title":"Electric.Replication.Changes.relation_name/0","doc":"","ref":"Electric.Replication.Changes.html#t:relation_name/0"},{"type":"type","title":"Electric.Replication.Changes.tag/0","doc":"Tag has the form of `origin@timestamp`, where origin is a unique source id\n(UUID for Satellite clients) and timestamp is millisecond-precision UTC unix timestamp","ref":"Electric.Replication.Changes.html#t:tag/0"},{"type":"type","title":"Electric.Replication.Changes.xid/0","doc":"","ref":"Electric.Replication.Changes.html#t:xid/0"},{"type":"module","title":"Electric.Replication.Changes.Column","doc":"","ref":"Electric.Replication.Changes.Column.html"},{"type":"type","title":"Electric.Replication.Changes.Column.t/0","doc":"","ref":"Electric.Replication.Changes.Column.html#t:t/0"},{"type":"module","title":"Electric.Replication.Changes.DeletedRecord","doc":"","ref":"Electric.Replication.Changes.DeletedRecord.html"},{"type":"type","title":"Electric.Replication.Changes.DeletedRecord.t/0","doc":"","ref":"Electric.Replication.Changes.DeletedRecord.html#t:t/0"},{"type":"module","title":"Electric.Replication.Changes.NewRecord","doc":"","ref":"Electric.Replication.Changes.NewRecord.html"},{"type":"type","title":"Electric.Replication.Changes.NewRecord.t/0","doc":"","ref":"Electric.Replication.Changes.NewRecord.html#t:t/0"},{"type":"module","title":"Electric.Replication.Changes.Relation","doc":"","ref":"Electric.Replication.Changes.Relation.html"},{"type":"type","title":"Electric.Replication.Changes.Relation.t/0","doc":"","ref":"Electric.Replication.Changes.Relation.html#t:t/0"},{"type":"module","title":"Electric.Replication.Changes.Transaction","doc":"","ref":"Electric.Replication.Changes.Transaction.html"},{"type":"function","title":"Electric.Replication.Changes.Transaction.prepend_change/2","doc":"","ref":"Electric.Replication.Changes.Transaction.html#prepend_change/2"},{"type":"type","title":"Electric.Replication.Changes.Transaction.t/0","doc":"","ref":"Electric.Replication.Changes.Transaction.html#t:t/0"},{"type":"module","title":"Electric.Replication.Changes.TruncatedRelation","doc":"","ref":"Electric.Replication.Changes.TruncatedRelation.html"},{"type":"type","title":"Electric.Replication.Changes.TruncatedRelation.t/0","doc":"","ref":"Electric.Replication.Changes.TruncatedRelation.html#t:t/0"},{"type":"module","title":"Electric.Replication.Changes.UpdatedRecord","doc":"","ref":"Electric.Replication.Changes.UpdatedRecord.html"},{"type":"function","title":"Electric.Replication.Changes.UpdatedRecord.new/1","doc":"","ref":"Electric.Replication.Changes.UpdatedRecord.html#new/1"},{"type":"type","title":"Electric.Replication.Changes.UpdatedRecord.t/0","doc":"","ref":"Electric.Replication.Changes.UpdatedRecord.html#t:t/0"},{"type":"module","title":"Electric.Replication.Eval.Env","doc":"Evaluation environment for parsing PostgreSQL expressions.\n\nWe have a need to parse PG expressions, and then be able to\nexecute them in Electric without reaching for Postgres on every operation.\nThis is achieved by parsing Postgres expressions, however Postgres has\na lot of features we're unlikely to support, and, moreover, very dynamic:\nnew features, new data types - everything can be redefined, including\nso-called \"preferred\" data types, new type categories, implicit casts, etc.\nRedefining all this for normal types is quite unlikely in the wild, but may be\nlater common for custom types.\n\nParsing PG expressions, we need to know what we support. It's then reasonable\nto have a good set of defaults we know how to deal with, but leave an escape hatch\nso that until we add support for pulling all this data from PG, we have a working\nsystem. Even afterwards, a set of PG functions using, say `PLSQL` is likely to use\ndefault PG functions, which we still need to know how to execute.\n\nThis module defines a struct that contains information, relevant to parsing PG\nstatements into something Electric can understand, while respecting PG types\nand function/operator overload selections.\n\nIt's also worth noting that our defaults, especially implicit casts specifically\nomit any \"system\" types (e.g. `regclass` or `pg_ndistinct`) because we're essentially\nnever going to have enough context in Electric to be able to correctly utilize those\ntypes.","ref":"Electric.Replication.Eval.Env.html"},{"type":"function","title":"Electric.Replication.Eval.Env.can_implicitly_coerce_types?/3","doc":"Check if a list of inputs can be implicitly coerced to a list of targets.\n\nNote that other functions may not exactly support all of types","ref":"Electric.Replication.Eval.Env.html#can_implicitly_coerce_types?/3"},{"type":"function","title":"Electric.Replication.Eval.Env.empty/1","doc":"Create a new empty environment, without any default functions or explicit casts","ref":"Electric.Replication.Eval.Env.html#empty/1"},{"type":"function","title":"Electric.Replication.Eval.Env.get_type_category/2","doc":"Get type category for the given type (possibly non-basic).","ref":"Electric.Replication.Eval.Env.html#get_type_category/2"},{"type":"function","title":"Electric.Replication.Eval.Env.get_unified_coercion_targets/4","doc":"","ref":"Electric.Replication.Eval.Env.html#get_unified_coercion_targets/4"},{"type":"function","title":"Electric.Replication.Eval.Env.implicitly_castable?/3","doc":"Check if one type is implicitly castable to another type in this environment.","ref":"Electric.Replication.Eval.Env.html#implicitly_castable?/3"},{"type":"function","title":"Electric.Replication.Eval.Env.is_preferred?/2","doc":"Check if type is preferred within the type category.","ref":"Electric.Replication.Eval.Env.html#is_preferred?/2"},{"type":"function","title":"Electric.Replication.Eval.Env.new/1","doc":"Create a new environment with known defaults, merging in provided keys","ref":"Electric.Replication.Eval.Env.html#new/1"},{"type":"function","title":"Electric.Replication.Eval.Env.parse_const/3","doc":"Parse an unknown value constant as a known type in the current environment.","ref":"Electric.Replication.Eval.Env.html#parse_const/3"},{"type":"type","title":"Electric.Replication.Eval.Env.basic_type/0","doc":"","ref":"Electric.Replication.Eval.Env.html#t:basic_type/0"},{"type":"type","title":"Electric.Replication.Eval.Env.basic_type_registry/0","doc":"","ref":"Electric.Replication.Eval.Env.html#t:basic_type_registry/0"},{"type":"type","title":"Electric.Replication.Eval.Env.cast_function/0","doc":"","ref":"Electric.Replication.Eval.Env.html#t:cast_function/0"},{"type":"type","title":"Electric.Replication.Eval.Env.cast_key/0","doc":"","ref":"Electric.Replication.Eval.Env.html#t:cast_key/0"},{"type":"type","title":"Electric.Replication.Eval.Env.cast_registry/0","doc":"","ref":"Electric.Replication.Eval.Env.html#t:cast_registry/0"},{"type":"type","title":"Electric.Replication.Eval.Env.env_property/0","doc":"","ref":"Electric.Replication.Eval.Env.html#t:env_property/0"},{"type":"type","title":"Electric.Replication.Eval.Env.flat_pg_type/0","doc":"","ref":"Electric.Replication.Eval.Env.html#t:flat_pg_type/0"},{"type":"type","title":"Electric.Replication.Eval.Env.func/0","doc":"","ref":"Electric.Replication.Eval.Env.html#t:func/0"},{"type":"type","title":"Electric.Replication.Eval.Env.func_id/0","doc":"","ref":"Electric.Replication.Eval.Env.html#t:func_id/0"},{"type":"type","title":"Electric.Replication.Eval.Env.funcs/0","doc":"","ref":"Electric.Replication.Eval.Env.html#t:funcs/0"},{"type":"type","title":"Electric.Replication.Eval.Env.implicit_cast_registry/0","doc":"","ref":"Electric.Replication.Eval.Env.html#t:implicit_cast_registry/0"},{"type":"type","title":"Electric.Replication.Eval.Env.pg_type/0","doc":"","ref":"Electric.Replication.Eval.Env.html#t:pg_type/0"},{"type":"type","title":"Electric.Replication.Eval.Env.t/0","doc":"","ref":"Electric.Replication.Eval.Env.html#t:t/0"},{"type":"type","title":"Electric.Replication.Eval.Env.type_info/0","doc":"","ref":"Electric.Replication.Eval.Env.html#t:type_info/0"},{"type":"module","title":"Electric.Replication.Eval.Env.BasicTypes","doc":"This module describes basic types, their categories, and if they are preferred within said category.\nInformation here is gathered from a system catalog `pg_type`, as described in\n[PG docs](https://www.postgresql.org/docs/current/catalog-pg-type.html).","ref":"Electric.Replication.Eval.Env.BasicTypes.html"},{"type":"module","title":"Known types - Electric.Replication.Eval.Env.BasicTypes","doc":"| type                    | category | preferred? |\n| ----------------------- | -------- | ---------- |\n| bool                    | boolean  | t          |\n| int2                    | numeric  |            |\n| int4                    | numeric  |            |\n| int8                    | numeric  |            |\n| float4                  | numeric  |            |\n| float8                  | numeric  | t          |\n| numeric                 | numeric  |            |\n| name                    | string   |            |\n| text                    | string   | t          |\n| varchar                 | string   |            |\n| date                    | datetime |            |\n| time                    | datetime |            |\n| timestamp               | datetime |            |\n| timestamptz             | datetime | t          |\n| interval                | timespan | t          |\n| unknown                 | unknown  |            |\n| bytea                   | user     |            |\n| uuid                    | user     |            |\n| anyarray                | pseudo   |            |\n| anycompatible           | pseudo   |            |\n| anycompatiblearray      | pseudo   |            |\n| anycompatiblemultirange | pseudo   |            |\n| anycompatiblenonarray   | pseudo   |            |\n| anycompatiblerange      | pseudo   |            |\n| anyelement              | pseudo   |            |\n| anyenum                 | pseudo   |            |\n| anymultirange           | pseudo   |            |\n| anynonarray             | pseudo   |            |\n| anyrange                | pseudo   |            |","ref":"Electric.Replication.Eval.Env.BasicTypes.html#module-known-types"},{"type":"function","title":"Electric.Replication.Eval.Env.BasicTypes.known/0","doc":"List all known basic types","ref":"Electric.Replication.Eval.Env.BasicTypes.html#known/0"},{"type":"function","title":"Examples - Electric.Replication.Eval.Env.BasicTypes.known/0","doc":"iex> noop(known()[:timestamptz])\n    %{category: :datetime, preferred?: true}","ref":"Electric.Replication.Eval.Env.BasicTypes.html#known/0-examples"},{"type":"function","title":"Electric.Replication.Eval.Env.BasicTypes.noop/1","doc":"","ref":"Electric.Replication.Eval.Env.BasicTypes.html#noop/1"},{"type":"module","title":"Electric.Replication.Eval.Env.ExplicitCasts","doc":"Postgres has explicit casts, achievable via `::type` calls.\nThis module defines implementations for a subset of known ones.\n\"function name\" column here is a function name in this module.","ref":"Electric.Replication.Eval.Env.ExplicitCasts.html"},{"type":"module","title":"List of explicit casts - Electric.Replication.Eval.Env.ExplicitCasts","doc":"| source    | target         | function name |\n| --------- | -------------- | ------------- |\n| bool      | int4           | bool_to_int4  |\n| char      | int4           |               |\n| int8      | bit            |               |\n| int4      | bit            |               |\n| int4      | bool           | int4_to_bool  |\n| int4      | char           |               |\n| text      | xml            |               |\n| lseg      | point          |               |\n| box       | point          |               |\n| box       | lseg           |               |\n| box       | circle         |               |\n| polygon   | box            |               |\n| polygon   | circle         |               |\n| polygon   | point          |               |\n| circle    | box            |               |\n| circle    | point          |               |\n| circle    | polygon        |               |\n| bpchar    | xml            |               |\n| varchar   | xml            |               |\n| bit       | int4           |               |\n| bit       | int8           |               |\n| jsonb     | bool           |               |\n| jsonb     | int8           |               |\n| jsonb     | int2           |               |\n| jsonb     | int4           |               |\n| jsonb     | float4         |               |\n| jsonb     | float8         |               |\n| jsonb     | numeric        |               |\n| int4range | int4multirange |               |\n| numrange  | nummultirange  |               |\n| tsrange   | tsmultirange   |               |\n| tstzrange | tstzmultirange |               |\n| daterange | datemultirange |               |\n| int8range | int8multirange |               |\n| xid8      | xid            |               |","ref":"Electric.Replication.Eval.Env.ExplicitCasts.html#module-list-of-explicit-casts"},{"type":"function","title":"Electric.Replication.Eval.Env.ExplicitCasts.bool_to_int4/1","doc":"","ref":"Electric.Replication.Eval.Env.ExplicitCasts.html#bool_to_int4/1"},{"type":"function","title":"Electric.Replication.Eval.Env.ExplicitCasts.int4_to_bool/1","doc":"","ref":"Electric.Replication.Eval.Env.ExplicitCasts.html#int4_to_bool/1"},{"type":"function","title":"Electric.Replication.Eval.Env.ExplicitCasts.known/0","doc":"","ref":"Electric.Replication.Eval.Env.ExplicitCasts.html#known/0"},{"type":"module","title":"Electric.Replication.Eval.Env.ImplicitCasts","doc":"List of all implicit casts in (raw) PostgreSQL. Does not account for custom casts, which\nare discouraged anyway. If needed, this list can be extended in `Electric.Replication.Eval.Env.new/1`\n\nThis list of implicit casts functions as-is, meaning that in Elixir land, we can just \"relabel\" the type,\nwithout doing any actual conversion, and it will work.\n\nTypes are always considered implicitly castable to themselves (as in PG code), but three casts are missing\nfrom this list: `time` to `timetz`, `timestamp` to `timestamptz`, and `date` to `timestamptz`. Reason for this is that the implicit\ncast appends a timezone of the server to the original type, which is not something that makes a whole\nlot of sense to do on Electric.\n\nDuplicated source and target usually mean that there is some property of the type that may be present\n(e.g. length of the `bit` type, or precision of `interval`) but shouldn't interfere with casting","ref":"Electric.Replication.Eval.Env.ImplicitCasts.html"},{"type":"module","title":"List of implicit casts - Electric.Replication.Eval.Env.ImplicitCasts","doc":"| source      | targets                           | function name     |\n| ----------- | --------------------------------- | ----------------- |\n| bit         | varbit,bit                        |                   |\n| bpchar      | text,name,varchar,bpchar          |                   |\n| char        | text                              |                   |\n| cidr        | inet                              |                   |\n| date        | timestamp                         | date_to_timestamp |\n| float4      | float8                            |                   |\n| int2        | float8,int8,int4,numeric,float4   |                   |\n| int4        | float4,float8,numeric,int8        |                   |\n| int8        | float8,float4,numeric             |                   |\n| interval    | interval                          |                   |\n| macaddr     | macaddr8                          |                   |\n| macaddr8    | macaddr                           |                   |\n| name        | text                              |                   |\n| numeric     | numeric,float8,float4             |                   |\n| text        | bpchar,varchar,name               |                   |\n| time        | interval                          |                   |\n| time        | time                              |                   |\n| timestamp   | timestamp                         |                   |\n| timestamptz | timestamptz                       |                   |\n| timetz      | timetz                            |                   |\n| varbit      | varbit,bit                        |                   |\n| varchar     | name,text,bpchar,varchar          |                   |","ref":"Electric.Replication.Eval.Env.ImplicitCasts.html#module-list-of-implicit-casts"},{"type":"function","title":"Electric.Replication.Eval.Env.ImplicitCasts.date_to_timestamp/1","doc":"","ref":"Electric.Replication.Eval.Env.ImplicitCasts.html#date_to_timestamp/1"},{"type":"function","title":"Electric.Replication.Eval.Env.ImplicitCasts.known/0","doc":"","ref":"Electric.Replication.Eval.Env.ImplicitCasts.html#known/0"},{"type":"module","title":"Electric.Replication.Eval.Env.KnownFunctions","doc":"","ref":"Electric.Replication.Eval.Env.KnownFunctions.html"},{"type":"function","title":"Electric.Replication.Eval.Env.KnownFunctions.arrays_overlap?/2","doc":"","ref":"Electric.Replication.Eval.Env.KnownFunctions.html#arrays_overlap?/2"},{"type":"function","title":"Electric.Replication.Eval.Env.KnownFunctions.bool_out/1","doc":"","ref":"Electric.Replication.Eval.Env.KnownFunctions.html#bool_out/1"},{"type":"function","title":"Electric.Replication.Eval.Env.KnownFunctions.date_subtract/2","doc":"","ref":"Electric.Replication.Eval.Env.KnownFunctions.html#date_subtract/2"},{"type":"function","title":"Electric.Replication.Eval.Env.KnownFunctions.known_functions/0","doc":"","ref":"Electric.Replication.Eval.Env.KnownFunctions.html#known_functions/0"},{"type":"function","title":"Electric.Replication.Eval.Env.KnownFunctions.known_operators/0","doc":"","ref":"Electric.Replication.Eval.Env.KnownFunctions.html#known_operators/0"},{"type":"function","title":"Electric.Replication.Eval.Env.KnownFunctions.left_array_contains_right?/2","doc":"","ref":"Electric.Replication.Eval.Env.KnownFunctions.html#left_array_contains_right?/2"},{"type":"function","title":"Electric.Replication.Eval.Env.KnownFunctions.naive_from_timestamptz/2","doc":"","ref":"Electric.Replication.Eval.Env.KnownFunctions.html#naive_from_timestamptz/2"},{"type":"function","title":"Electric.Replication.Eval.Env.KnownFunctions.not_ilike?/2","doc":"","ref":"Electric.Replication.Eval.Env.KnownFunctions.html#not_ilike?/2"},{"type":"function","title":"Electric.Replication.Eval.Env.KnownFunctions.not_like?/2","doc":"","ref":"Electric.Replication.Eval.Env.KnownFunctions.html#not_like?/2"},{"type":"function","title":"Electric.Replication.Eval.Env.KnownFunctions.right_array_contains_left?/2","doc":"","ref":"Electric.Replication.Eval.Env.KnownFunctions.html#right_array_contains_left?/2"},{"type":"function","title":"Electric.Replication.Eval.Env.KnownFunctions.text_concat/2","doc":"","ref":"Electric.Replication.Eval.Env.KnownFunctions.html#text_concat/2"},{"type":"function","title":"Electric.Replication.Eval.Env.KnownFunctions.timestamptz_from_naive/2","doc":"","ref":"Electric.Replication.Eval.Env.KnownFunctions.html#timestamptz_from_naive/2"},{"type":"module","title":"Electric.Replication.Eval.Expr","doc":"Parsed expression, available for evaluation using the runner","ref":"Electric.Replication.Eval.Expr.html"},{"type":"type","title":"Electric.Replication.Eval.Expr.t/0","doc":"","ref":"Electric.Replication.Eval.Expr.html#t:t/0"},{"type":"type","title":"Electric.Replication.Eval.Expr.used_refs/0","doc":"","ref":"Electric.Replication.Eval.Expr.html#t:used_refs/0"},{"type":"module","title":"Electric.Replication.Eval.KnownDefinition","doc":"Special module to be `use`-d to define translation of PostgreSQL\noperators and functions into Elixir calls.","ref":"Electric.Replication.Eval.KnownDefinition.html"},{"type":"macro","title":"Electric.Replication.Eval.KnownDefinition.before_compile/1","doc":"","ref":"Electric.Replication.Eval.KnownDefinition.html#before_compile/1"},{"type":"macro","title":"Electric.Replication.Eval.KnownDefinition.defcompare/2","doc":"","ref":"Electric.Replication.Eval.KnownDefinition.html#defcompare/2"},{"type":"macro","title":"Electric.Replication.Eval.KnownDefinition.defpostgres/3","doc":"Define a postgres operator or function and it's implementation in Elixir.","ref":"Electric.Replication.Eval.KnownDefinition.html#defpostgres/3"},{"type":"function","title":"Electric.Replication.Eval.KnownDefinition.expand_categories/1","doc":"","ref":"Electric.Replication.Eval.KnownDefinition.html#expand_categories/1"},{"type":"module","title":"Electric.Replication.Eval.Lookups","doc":"","ref":"Electric.Replication.Eval.Lookups.html"},{"type":"function","title":"Electric.Replication.Eval.Lookups.pick_concrete_function_overload/3","doc":"Given multiple possible function overloads (same name and arity), try to\nfind a concrete implementation that matches the argument types.\n\nRules for picking a function overload closely mimic those outlined in [postgres\ndocumentation](https://www.postgresql.org/docs/current/typeconv-func.html):\n\n1. Check if there is an overload where all variable types match exactly\n2. Check if only one overload remains based on implicit conversion rules\n   (unknowns are considered always matching), discard those that cannot\n   be applied even after implicit conversion\n3. Check if only one overload remains based on most exact type matches\n4. Keep overloads that accept most preferred types in each conversion spot\n5. If there are any unknowns, for each position first look for any overloads that\n   accept `string` category, and if none found, check if all overloads accept\n   the same type category. If that fails, keep all overloads, or pick any that\n   don't accept picked category\n6. If there are both unknown and known arguments, and all known arguments have\n   the same type category, assume unknowns have the same type category and look\n   for overloads that fit.\n\nIf exactly one overload matched after those steps, pick it, otherwise fail.","ref":"Electric.Replication.Eval.Lookups.html#pick_concrete_function_overload/3"},{"type":"function","title":"Electric.Replication.Eval.Lookups.pick_concrete_operator_overload/3","doc":"Given multiple possible operator overloads (same name and arity), try to\nfind a concrete implementation that matches the argument types.\n\nOperators can only be 1 or 2-arity.\n\nRules for picking a operation overload closely mimic those outlined in [postgres\ndocumentation](https://www.postgresql.org/docs/current/typeconv-oper.html), and\nmostly match `pick_concrete_function_overload/3`.","ref":"Electric.Replication.Eval.Lookups.html#pick_concrete_operator_overload/3"},{"type":"function","title":"Electric.Replication.Eval.Lookups.pick_union_type/2","doc":"Given a list of types, get a candidate type that best represents the union of all types.\n\nAlgorithm implements Postgres type resolution for `UNION`, `CASE`, and related constructs, like\n`ARRAY[]` constructor syntax. They are outlined in\n[documentation](https://www.postgresql.org/docs/current/typeconv-union-case.html).\n\n1. If all inputs are of the same type, and it is not unknown, resolve as that type.\n2. If any input is of a domain type, treat it as being of the domain's base type for all subsequent steps.\n3. If all inputs are of type unknown, resolve as type text (the preferred type of the string category).\n   Otherwise, unknown inputs are ignored for the purposes of the remaining rules.\n4. If the non-unknown inputs are not all of the same type category, fail.\n5. Select the first non-unknown input type as the candidate type, then consider each other non-unknown input type, left to right.\n   If the candidate type can be implicitly converted to the other type but not vice-versa, select the other type as the new\n   candidate type. Then continue considering the remaining inputs.\n   If, at any stage of this process, a preferred type is selected, stop considering additional inputs.\n6. Convert all inputs to the final candidate type. Fail if there is not an implicit conversion from a given input type to the candidate type.","ref":"Electric.Replication.Eval.Lookups.html#pick_union_type/2"},{"type":"module","title":"Electric.Replication.Eval.Parser","doc":"","ref":"Electric.Replication.Eval.Parser.html"},{"type":"function","title":"Electric.Replication.Eval.Parser.cast_null/1","doc":"","ref":"Electric.Replication.Eval.Parser.html#cast_null/1"},{"type":"function","title":"Electric.Replication.Eval.Parser.find_refs/2","doc":"","ref":"Electric.Replication.Eval.Parser.html#find_refs/2"},{"type":"function","title":"Electric.Replication.Eval.Parser.parse_and_validate_expression/3","doc":"","ref":"Electric.Replication.Eval.Parser.html#parse_and_validate_expression/3"},{"type":"function","title":"Electric.Replication.Eval.Parser.parse_and_validate_expression!/3","doc":"","ref":"Electric.Replication.Eval.Parser.html#parse_and_validate_expression!/3"},{"type":"function","title":"Electric.Replication.Eval.Parser.unwrap_node_string/1","doc":"","ref":"Electric.Replication.Eval.Parser.html#unwrap_node_string/1"},{"type":"type","title":"Electric.Replication.Eval.Parser.refs_map/0","doc":"","ref":"Electric.Replication.Eval.Parser.html#t:refs_map/0"},{"type":"type","title":"Electric.Replication.Eval.Parser.tree_part/0","doc":"","ref":"Electric.Replication.Eval.Parser.html#t:tree_part/0"},{"type":"module","title":"Electric.Replication.Eval.Parser.Const","doc":"","ref":"Electric.Replication.Eval.Parser.Const.html"},{"type":"module","title":"Electric.Replication.Eval.Parser.Func","doc":"","ref":"Electric.Replication.Eval.Parser.Func.html"},{"type":"module","title":"Electric.Replication.Eval.Parser.Ref","doc":"","ref":"Electric.Replication.Eval.Parser.Ref.html"},{"type":"module","title":"Electric.Replication.Eval.Parser.UnknownConst","doc":"","ref":"Electric.Replication.Eval.Parser.UnknownConst.html"},{"type":"module","title":"Electric.Replication.Eval.Runner","doc":"","ref":"Electric.Replication.Eval.Runner.html"},{"type":"function","title":"Electric.Replication.Eval.Runner.execute/2","doc":"Run a PG function parsed by `Electric.Replication.Eval.Parser` based on the inputs","ref":"Electric.Replication.Eval.Runner.html#execute/2"},{"type":"function","title":"Electric.Replication.Eval.Runner.record_to_ref_values/3","doc":"Generate a ref values object based on the record and a given table name","ref":"Electric.Replication.Eval.Runner.html#record_to_ref_values/3"},{"type":"function","title":"Examples - Electric.Replication.Eval.Runner.record_to_ref_values/3","doc":"iex> used_refs = %{[\"id\"] => :int8, [\"created_at\"] => :timestamp}\n    iex> record_to_ref_values(used_refs, %{\"id\" => \"80\", \"created_at\" => \"2020-01-01T11:00:00Z\"})\n    %{\n      [\"id\"] => 80,\n      [\"created_at\"] => ~N[2020-01-01 11:00:00]\n    }","ref":"Electric.Replication.Eval.Runner.html#record_to_ref_values/3-examples"},{"type":"module","title":"Electric.Replication.LogOffset","doc":"Uniquely identifies an operation inside the shape log.\nCombines a transaction ID with operation ID.","ref":"Electric.Replication.LogOffset.html"},{"type":"function","title":"Electric.Replication.LogOffset.before_all/0","doc":"An offset that is smaller than all offsets in the log.","ref":"Electric.Replication.LogOffset.html#before_all/0"},{"type":"function","title":"Examples - Electric.Replication.LogOffset.before_all/0","doc":"iex> compare(before_all(), first())\n    :lt","ref":"Electric.Replication.LogOffset.html#before_all/0-examples"},{"type":"function","title":"Electric.Replication.LogOffset.compare/2","doc":"Compare two log offsets","ref":"Electric.Replication.LogOffset.html#compare/2"},{"type":"function","title":"Examples - Electric.Replication.LogOffset.compare/2","doc":"iex> compare(new(10, 0), new(10, 1))\n    :lt\n\n    iex> compare(new(9, 1), new(10, 1))\n    :lt\n\n    iex> compare(new(10, 1), new(10, 0))\n    :gt\n\n    iex> compare(new(11, 1), new(10, 1))\n    :gt\n\n    iex> compare(new(0, 0), before_all())\n    :gt\n\n    iex> compare(new(10, 0), %LogOffset{tx_offset: 10, op_offset: 0})\n    :eq","ref":"Electric.Replication.LogOffset.html#compare/2-examples"},{"type":"function","title":"Electric.Replication.LogOffset.first/0","doc":"The first possible offset in the log.","ref":"Electric.Replication.LogOffset.html#first/0"},{"type":"function","title":"Electric.Replication.LogOffset.from_string/1","doc":"Parse the given string as a LogOffset value.","ref":"Electric.Replication.LogOffset.html#from_string/1"},{"type":"function","title":"Examples - Electric.Replication.LogOffset.from_string/1","doc":"iex> from_string(\"-1\")\n    {:ok, before_all()}\n\n    iex> from_string(\"0_0\")\n    {:ok, %LogOffset{tx_offset: 0, op_offset: 0}}\n\n    iex> from_string(\"11_13\")\n    {:ok, %LogOffset{tx_offset: 11, op_offset: 13}}\n\n    iex> from_string(\"0_02\")\n    {:ok, %LogOffset{tx_offset: 0, op_offset: 2}}\n\n    iex> from_string(\"1_2_3\")\n    {:error, \"has invalid format\"}\n\n    iex> from_string(\"1_2 \")\n    {:error, \"has invalid format\"}\n\n    iex> from_string(\"10\")\n    {:error, \"has invalid format\"}\n\n    iex> from_string(\"10_32.1\")\n    {:error, \"has invalid format\"}","ref":"Electric.Replication.LogOffset.html#from_string/1-examples"},{"type":"function","title":"Electric.Replication.LogOffset.increment/2","doc":"Increments the offset of the change inside the transaction.","ref":"Electric.Replication.LogOffset.html#increment/2"},{"type":"function","title":"Examples - Electric.Replication.LogOffset.increment/2","doc":"iex> increment(new(10, 5))\n    %LogOffset{tx_offset: 10, op_offset: 6}\n\n    iex> compare(new(10, 5) |> increment, new(10, 5))\n    :gt\n\n    iex> increment(new(10, 5), 5)\n    %LogOffset{tx_offset: 10, op_offset: 10}\n\n    iex> compare(new(10, 1) |> increment(4), new(10, 5))\n    :eq","ref":"Electric.Replication.LogOffset.html#increment/2-examples"},{"type":"macro","title":"Electric.Replication.LogOffset.is_log_offset_lt/2","doc":"","ref":"Electric.Replication.LogOffset.html#is_log_offset_lt/2"},{"type":"function","title":"Electric.Replication.LogOffset.last/0","doc":"The last possible offset in the log.","ref":"Electric.Replication.LogOffset.html#last/0"},{"type":"function","title":"Examples - Electric.Replication.LogOffset.last/0","doc":"iex> compare(first(), last())\n    :lt\n\n    iex> compare(new(Lsn.from_integer(10), 0), last())\n    :lt","ref":"Electric.Replication.LogOffset.html#last/0-examples"},{"type":"function","title":"Electric.Replication.LogOffset.new/1","doc":"","ref":"Electric.Replication.LogOffset.html#new/1"},{"type":"function","title":"Electric.Replication.LogOffset.new/2","doc":"Create a new LogOffset value.","ref":"Electric.Replication.LogOffset.html#new/2"},{"type":"function","title":"Examples - Electric.Replication.LogOffset.new/2","doc":"iex> new(Lsn.from_integer(10), 0)\n    %LogOffset{tx_offset: 10, op_offset: 0}\n\n    iex> new(11, 3)\n    %LogOffset{tx_offset: 11, op_offset: 3}\n\n    iex> new(to_tuple(new(Lsn.from_integer(5), 1)))\n    %LogOffset{tx_offset: 5, op_offset: 1}\n\n    iex> new({11, 3})\n    %LogOffset{tx_offset: 11, op_offset: 3}\n\n    iex> new({11, 3.2})\n    ** (FunctionClauseError) no function clause matching in Electric.Replication.LogOffset.new/2\n\n    iex> new(10, -2)\n    ** (FunctionClauseError) no function clause matching in Electric.Replication.LogOffset.new/2","ref":"Electric.Replication.LogOffset.html#new/2-examples"},{"type":"function","title":"Electric.Replication.LogOffset.to_iolist/1","doc":"Format a LogOffset value to its text representation in an iolist.","ref":"Electric.Replication.LogOffset.html#to_iolist/1"},{"type":"function","title":"Examples - Electric.Replication.LogOffset.to_iolist/1","doc":"iex> to_iolist(first())\n    [\"0\", ?_, \"0\"]\n\n    iex> to_iolist(new(Lsn.from_integer(10), 3))\n    [\"10\", ?_, \"3\"]\n\n    iex> to_iolist(before_all())\n    [\"-1\"]","ref":"Electric.Replication.LogOffset.html#to_iolist/1-examples"},{"type":"function","title":"Electric.Replication.LogOffset.to_tuple/1","doc":"Returns a tuple with the tx_offset and the op_offset.","ref":"Electric.Replication.LogOffset.html#to_tuple/1"},{"type":"function","title":"Examples - Electric.Replication.LogOffset.to_tuple/1","doc":"iex> to_tuple(first())\n    {0, 0}\n\n    iex> to_tuple(new(Lsn.from_integer(10), 3))\n    {10, 3}","ref":"Electric.Replication.LogOffset.html#to_tuple/1-examples"},{"type":"type","title":"Electric.Replication.LogOffset.int64/0","doc":"","ref":"Electric.Replication.LogOffset.html#t:int64/0"},{"type":"type","title":"Electric.Replication.LogOffset.t/0","doc":"","ref":"Electric.Replication.LogOffset.html#t:t/0"},{"type":"module","title":"Electric.Replication.PostgresInterop.Casting","doc":"","ref":"Electric.Replication.PostgresInterop.Casting.html"},{"type":"function","title":"Electric.Replication.PostgresInterop.Casting.ilike?/2","doc":"","ref":"Electric.Replication.PostgresInterop.Casting.html#ilike?/2"},{"type":"macro","title":"Electric.Replication.PostgresInterop.Casting.is_pg_int2/1","doc":"","ref":"Electric.Replication.PostgresInterop.Casting.html#is_pg_int2/1"},{"type":"macro","title":"Electric.Replication.PostgresInterop.Casting.is_pg_int4/1","doc":"","ref":"Electric.Replication.PostgresInterop.Casting.html#is_pg_int4/1"},{"type":"macro","title":"Electric.Replication.PostgresInterop.Casting.is_pg_int8/1","doc":"","ref":"Electric.Replication.PostgresInterop.Casting.html#is_pg_int8/1"},{"type":"function","title":"Electric.Replication.PostgresInterop.Casting.like?/3","doc":"LIKE function from SQL. Case sensitive by default.","ref":"Electric.Replication.PostgresInterop.Casting.html#like?/3"},{"type":"function","title":"Examples - Electric.Replication.PostgresInterop.Casting.like?/3","doc":"iex> like?(\"hello\", \"hell_\")\n    true\n\n    iex> like?(\"helloo\", \"hell_\")\n    false\n\n    iex> like?(\"helloo\", \"%o_\")\n    true\n\n    iex> like?(\"HELLO\", \"hello\")\n    false\n\n    iex> like?(\"HELLO\", \"hello\", true)\n    true","ref":"Electric.Replication.PostgresInterop.Casting.html#like?/3-examples"},{"type":"function","title":"Electric.Replication.PostgresInterop.Casting.parse_bool/1","doc":"","ref":"Electric.Replication.PostgresInterop.Casting.html#parse_bool/1"},{"type":"function","title":"Electric.Replication.PostgresInterop.Casting.parse_date/1","doc":"","ref":"Electric.Replication.PostgresInterop.Casting.html#parse_date/1"},{"type":"function","title":"Electric.Replication.PostgresInterop.Casting.parse_float8/1","doc":"","ref":"Electric.Replication.PostgresInterop.Casting.html#parse_float8/1"},{"type":"function","title":"Electric.Replication.PostgresInterop.Casting.parse_int2/1","doc":"","ref":"Electric.Replication.PostgresInterop.Casting.html#parse_int2/1"},{"type":"function","title":"Electric.Replication.PostgresInterop.Casting.parse_int4/1","doc":"","ref":"Electric.Replication.PostgresInterop.Casting.html#parse_int4/1"},{"type":"function","title":"Electric.Replication.PostgresInterop.Casting.parse_int8/1","doc":"","ref":"Electric.Replication.PostgresInterop.Casting.html#parse_int8/1"},{"type":"function","title":"Electric.Replication.PostgresInterop.Casting.parse_time/1","doc":"","ref":"Electric.Replication.PostgresInterop.Casting.html#parse_time/1"},{"type":"function","title":"Electric.Replication.PostgresInterop.Casting.parse_timestamp/1","doc":"","ref":"Electric.Replication.PostgresInterop.Casting.html#parse_timestamp/1"},{"type":"function","title":"Electric.Replication.PostgresInterop.Casting.parse_timestamptz/1","doc":"","ref":"Electric.Replication.PostgresInterop.Casting.html#parse_timestamptz/1"},{"type":"function","title":"Electric.Replication.PostgresInterop.Casting.parse_uuid/1","doc":"","ref":"Electric.Replication.PostgresInterop.Casting.html#parse_uuid/1"},{"type":"function","title":"Electric.Replication.PostgresInterop.Casting.values_distinct?/3","doc":"","ref":"Electric.Replication.PostgresInterop.Casting.html#values_distinct?/3"},{"type":"function","title":"Electric.Replication.PostgresInterop.Casting.values_not_distinct?/3","doc":"","ref":"Electric.Replication.PostgresInterop.Casting.html#values_not_distinct?/3"},{"type":"module","title":"Electric.Replication.ShapeLogCollector","doc":"When any txn comes from postgres, we need to store it into the\nlog for this shape if and only if it has txid >= xmin of the snapshot.","ref":"Electric.Replication.ShapeLogCollector.html"},{"type":"function","title":"Electric.Replication.ShapeLogCollector.handle_call/3","doc":"","ref":"Electric.Replication.ShapeLogCollector.html#handle_call/3"},{"type":"function","title":"Electric.Replication.ShapeLogCollector.handle_cancel/3","doc":"","ref":"Electric.Replication.ShapeLogCollector.html#handle_cancel/3"},{"type":"function","title":"Electric.Replication.ShapeLogCollector.handle_demand/2","doc":"","ref":"Electric.Replication.ShapeLogCollector.html#handle_demand/2"},{"type":"function","title":"Electric.Replication.ShapeLogCollector.handle_relation_msg/2","doc":"","ref":"Electric.Replication.ShapeLogCollector.html#handle_relation_msg/2"},{"type":"function","title":"Electric.Replication.ShapeLogCollector.handle_subscribe/4","doc":"","ref":"Electric.Replication.ShapeLogCollector.html#handle_subscribe/4"},{"type":"function","title":"Electric.Replication.ShapeLogCollector.init/1","doc":"","ref":"Electric.Replication.ShapeLogCollector.html#init/1"},{"type":"function","title":"Electric.Replication.ShapeLogCollector.name/1","doc":"","ref":"Electric.Replication.ShapeLogCollector.html#name/1"},{"type":"function","title":"Electric.Replication.ShapeLogCollector.start_link/1","doc":"","ref":"Electric.Replication.ShapeLogCollector.html#start_link/1"},{"type":"function","title":"Electric.Replication.ShapeLogCollector.store_transaction/2","doc":"","ref":"Electric.Replication.ShapeLogCollector.html#store_transaction/2"},{"type":"module","title":"Electric.Replication.Supervisor","doc":"","ref":"Electric.Replication.Supervisor.html"},{"type":"function","title":"Electric.Replication.Supervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Electric.Replication.Supervisor.html#child_spec/1"},{"type":"function","title":"Electric.Replication.Supervisor.name/1","doc":"","ref":"Electric.Replication.Supervisor.html#name/1"},{"type":"function","title":"Electric.Replication.Supervisor.start_link/1","doc":"","ref":"Electric.Replication.Supervisor.html#start_link/1"},{"type":"module","title":"Electric.Schema","doc":"","ref":"Electric.Schema.html"},{"type":"function","title":"Electric.Schema.from_column_info/1","doc":"Convert column information into a schema map","ref":"Electric.Schema.html#from_column_info/1"},{"type":"type","title":"Electric.Schema.column_name/0","doc":"","ref":"Electric.Schema.html#t:column_name/0"},{"type":"type","title":"Electric.Schema.schema/0","doc":"","ref":"Electric.Schema.html#t:schema/0"},{"type":"type","title":"Electric.Schema.type_name/0","doc":"","ref":"Electric.Schema.html#t:type_name/0"},{"type":"module","title":"Electric.ServiceStatus","doc":"","ref":"Electric.ServiceStatus.html"},{"type":"function","title":"Electric.ServiceStatus.check/1","doc":"","ref":"Electric.ServiceStatus.html#check/1"},{"type":"type","title":"Electric.ServiceStatus.status/0","doc":"","ref":"Electric.ServiceStatus.html#t:status/0"},{"type":"module","title":"Electric.ShapeCache","doc":"","ref":"Electric.ShapeCache.html"},{"type":"function","title":"Electric.ShapeCache.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Electric.ShapeCache.html#child_spec/1"},{"type":"function","title":"Electric.ShapeCache.get_shape_meta_table/1","doc":"","ref":"Electric.ShapeCache.html#get_shape_meta_table/1"},{"type":"function","title":"Electric.ShapeCache.name/1","doc":"","ref":"Electric.ShapeCache.html#name/1"},{"type":"function","title":"Electric.ShapeCache.start_link/1","doc":"","ref":"Electric.ShapeCache.html#start_link/1"},{"type":"type","title":"Electric.ShapeCache.shape_handle/0","doc":"","ref":"Electric.ShapeCache.html#t:shape_handle/0"},{"type":"module","title":"Electric.ShapeCache.CrashingFileStorage","doc":"A thing wrapper module around FileStorage that can be configured to raise an error after a\ncertain number of writes.","ref":"Electric.ShapeCache.CrashingFileStorage.html"},{"type":"function","title":"Electric.ShapeCache.CrashingFileStorage.append_to_log!/2","doc":"","ref":"Electric.ShapeCache.CrashingFileStorage.html#append_to_log!/2"},{"type":"function","title":"Electric.ShapeCache.CrashingFileStorage.cleanup!/1","doc":"","ref":"Electric.ShapeCache.CrashingFileStorage.html#cleanup!/1"},{"type":"function","title":"Electric.ShapeCache.CrashingFileStorage.for_shape/2","doc":"","ref":"Electric.ShapeCache.CrashingFileStorage.html#for_shape/2"},{"type":"function","title":"Electric.ShapeCache.CrashingFileStorage.get_all_stored_shapes/1","doc":"","ref":"Electric.ShapeCache.CrashingFileStorage.html#get_all_stored_shapes/1"},{"type":"function","title":"Electric.ShapeCache.CrashingFileStorage.get_chunk_end_log_offset/2","doc":"","ref":"Electric.ShapeCache.CrashingFileStorage.html#get_chunk_end_log_offset/2"},{"type":"function","title":"Electric.ShapeCache.CrashingFileStorage.get_current_position/1","doc":"","ref":"Electric.ShapeCache.CrashingFileStorage.html#get_current_position/1"},{"type":"function","title":"Electric.ShapeCache.CrashingFileStorage.get_log_stream/3","doc":"","ref":"Electric.ShapeCache.CrashingFileStorage.html#get_log_stream/3"},{"type":"function","title":"Electric.ShapeCache.CrashingFileStorage.get_snapshot/1","doc":"","ref":"Electric.ShapeCache.CrashingFileStorage.html#get_snapshot/1"},{"type":"function","title":"Electric.ShapeCache.CrashingFileStorage.get_total_disk_usage/1","doc":"","ref":"Electric.ShapeCache.CrashingFileStorage.html#get_total_disk_usage/1"},{"type":"function","title":"Electric.ShapeCache.CrashingFileStorage.initialise/1","doc":"","ref":"Electric.ShapeCache.CrashingFileStorage.html#initialise/1"},{"type":"function","title":"Electric.ShapeCache.CrashingFileStorage.make_new_snapshot!/2","doc":"","ref":"Electric.ShapeCache.CrashingFileStorage.html#make_new_snapshot!/2"},{"type":"function","title":"Electric.ShapeCache.CrashingFileStorage.mark_snapshot_as_started/1","doc":"","ref":"Electric.ShapeCache.CrashingFileStorage.html#mark_snapshot_as_started/1"},{"type":"function","title":"Electric.ShapeCache.CrashingFileStorage.set_shape_definition/2","doc":"","ref":"Electric.ShapeCache.CrashingFileStorage.html#set_shape_definition/2"},{"type":"function","title":"Electric.ShapeCache.CrashingFileStorage.set_snapshot_xmin/2","doc":"","ref":"Electric.ShapeCache.CrashingFileStorage.html#set_snapshot_xmin/2"},{"type":"function","title":"Electric.ShapeCache.CrashingFileStorage.shared_opts/1","doc":"","ref":"Electric.ShapeCache.CrashingFileStorage.html#shared_opts/1"},{"type":"function","title":"Electric.ShapeCache.CrashingFileStorage.snapshot_started?/1","doc":"","ref":"Electric.ShapeCache.CrashingFileStorage.html#snapshot_started?/1"},{"type":"function","title":"Electric.ShapeCache.CrashingFileStorage.start_link/1","doc":"","ref":"Electric.ShapeCache.CrashingFileStorage.html#start_link/1"},{"type":"function","title":"Electric.ShapeCache.CrashingFileStorage.unsafe_cleanup!/1","doc":"","ref":"Electric.ShapeCache.CrashingFileStorage.html#unsafe_cleanup!/1"},{"type":"module","title":"Electric.ShapeCache.FileStorage","doc":"","ref":"Electric.ShapeCache.FileStorage.html"},{"type":"function","title":"Electric.ShapeCache.FileStorage.child_spec/1","doc":"","ref":"Electric.ShapeCache.FileStorage.html#child_spec/1"},{"type":"module","title":"Electric.ShapeCache.InMemoryStorage","doc":"","ref":"Electric.ShapeCache.InMemoryStorage.html"},{"type":"function","title":"Electric.ShapeCache.InMemoryStorage.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Electric.ShapeCache.InMemoryStorage.html#child_spec/1"},{"type":"function","title":"Electric.ShapeCache.InMemoryStorage.name/2","doc":"","ref":"Electric.ShapeCache.InMemoryStorage.html#name/2"},{"type":"module","title":"Electric.ShapeCache.LogChunker","doc":"","ref":"Electric.ShapeCache.LogChunker.html"},{"type":"function","title":"Electric.ShapeCache.LogChunker.default_chunk_size_threshold/0","doc":"","ref":"Electric.ShapeCache.LogChunker.html#default_chunk_size_threshold/0"},{"type":"function","title":"Electric.ShapeCache.LogChunker.fit_into_chunk/3","doc":"Check if adding the given number of bytes to the current chunk would exceed the threshold.\n\nReturns either an ok-tuple with the new total chunk size or a threshold_exceeded-tuple with the\nnew chunk size of 0.","ref":"Electric.ShapeCache.LogChunker.html#fit_into_chunk/3"},{"type":"module","title":"Electric.ShapeCache.ShapeStatus","doc":"Keeps track of shape state.\n\nCan recover basic persisted shape metadata from shape storage to repopulate\nthe in-memory cache.\n\nThe shape cache then loads this and starts processes (storage and consumer)\nfor each `{shape_handle, %Shape{}}` pair. These then use their attached storage\nto recover the status information for the shape (snapshot xmin and latest\noffset).\n\nThe ETS metadata table name is part of the config because we need to be able\nto access the data in the ETS from anywhere, so there's an internal api,\nusing the full state and an external api using just the table name.","ref":"Electric.ShapeCache.ShapeStatus.html"},{"type":"function","title":"Electric.ShapeCache.ShapeStatus.add_shape/2","doc":"","ref":"Electric.ShapeCache.ShapeStatus.html#add_shape/2"},{"type":"function","title":"Electric.ShapeCache.ShapeStatus.get_existing_shape/2","doc":"","ref":"Electric.ShapeCache.ShapeStatus.html#get_existing_shape/2"},{"type":"function","title":"Electric.ShapeCache.ShapeStatus.initialise/1","doc":"","ref":"Electric.ShapeCache.ShapeStatus.html#initialise/1"},{"type":"function","title":"Electric.ShapeCache.ShapeStatus.initialise_shape/4","doc":"","ref":"Electric.ShapeCache.ShapeStatus.html#initialise_shape/4"},{"type":"function","title":"Electric.ShapeCache.ShapeStatus.latest_offset/2","doc":"","ref":"Electric.ShapeCache.ShapeStatus.html#latest_offset/2"},{"type":"function","title":"Electric.ShapeCache.ShapeStatus.latest_offset!/2","doc":"","ref":"Electric.ShapeCache.ShapeStatus.html#latest_offset!/2"},{"type":"function","title":"Electric.ShapeCache.ShapeStatus.list_shapes/1","doc":"","ref":"Electric.ShapeCache.ShapeStatus.html#list_shapes/1"},{"type":"function","title":"Electric.ShapeCache.ShapeStatus.mark_snapshot_started/2","doc":"","ref":"Electric.ShapeCache.ShapeStatus.html#mark_snapshot_started/2"},{"type":"function","title":"Electric.ShapeCache.ShapeStatus.remove_shape/2","doc":"","ref":"Electric.ShapeCache.ShapeStatus.html#remove_shape/2"},{"type":"function","title":"Electric.ShapeCache.ShapeStatus.set_latest_offset/3","doc":"","ref":"Electric.ShapeCache.ShapeStatus.html#set_latest_offset/3"},{"type":"function","title":"Electric.ShapeCache.ShapeStatus.set_snapshot_xmin/3","doc":"","ref":"Electric.ShapeCache.ShapeStatus.html#set_snapshot_xmin/3"},{"type":"function","title":"Electric.ShapeCache.ShapeStatus.snapshot_started?/2","doc":"","ref":"Electric.ShapeCache.ShapeStatus.html#snapshot_started?/2"},{"type":"function","title":"Electric.ShapeCache.ShapeStatus.snapshot_xmin/2","doc":"","ref":"Electric.ShapeCache.ShapeStatus.html#snapshot_xmin/2"},{"type":"type","title":"Electric.ShapeCache.ShapeStatus.option/0","doc":"","ref":"Electric.ShapeCache.ShapeStatus.html#t:option/0"},{"type":"type","title":"Electric.ShapeCache.ShapeStatus.options/0","doc":"","ref":"Electric.ShapeCache.ShapeStatus.html#t:options/0"},{"type":"type","title":"Electric.ShapeCache.ShapeStatus.shape_handle/0","doc":"","ref":"Electric.ShapeCache.ShapeStatus.html#t:shape_handle/0"},{"type":"type","title":"Electric.ShapeCache.ShapeStatus.t/0","doc":"","ref":"Electric.ShapeCache.ShapeStatus.html#t:t/0"},{"type":"type","title":"Electric.ShapeCache.ShapeStatus.table/0","doc":"","ref":"Electric.ShapeCache.ShapeStatus.html#t:table/0"},{"type":"type","title":"Electric.ShapeCache.ShapeStatus.xmin/0","doc":"","ref":"Electric.ShapeCache.ShapeStatus.html#t:xmin/0"},{"type":"behaviour","title":"Electric.ShapeCache.ShapeStatusBehaviour","doc":"Behaviour defining the ShapeStatus functions to be used in mocks","ref":"Electric.ShapeCache.ShapeStatusBehaviour.html"},{"type":"callback","title":"Electric.ShapeCache.ShapeStatusBehaviour.add_shape/2","doc":"","ref":"Electric.ShapeCache.ShapeStatusBehaviour.html#c:add_shape/2"},{"type":"callback","title":"Electric.ShapeCache.ShapeStatusBehaviour.get_existing_shape/2","doc":"","ref":"Electric.ShapeCache.ShapeStatusBehaviour.html#c:get_existing_shape/2"},{"type":"callback","title":"Electric.ShapeCache.ShapeStatusBehaviour.initialise/1","doc":"","ref":"Electric.ShapeCache.ShapeStatusBehaviour.html#c:initialise/1"},{"type":"callback","title":"Electric.ShapeCache.ShapeStatusBehaviour.initialise_shape/4","doc":"","ref":"Electric.ShapeCache.ShapeStatusBehaviour.html#c:initialise_shape/4"},{"type":"callback","title":"Electric.ShapeCache.ShapeStatusBehaviour.list_shapes/1","doc":"","ref":"Electric.ShapeCache.ShapeStatusBehaviour.html#c:list_shapes/1"},{"type":"callback","title":"Electric.ShapeCache.ShapeStatusBehaviour.mark_snapshot_started/2","doc":"","ref":"Electric.ShapeCache.ShapeStatusBehaviour.html#c:mark_snapshot_started/2"},{"type":"callback","title":"Electric.ShapeCache.ShapeStatusBehaviour.remove_shape/2","doc":"","ref":"Electric.ShapeCache.ShapeStatusBehaviour.html#c:remove_shape/2"},{"type":"callback","title":"Electric.ShapeCache.ShapeStatusBehaviour.set_latest_offset/3","doc":"","ref":"Electric.ShapeCache.ShapeStatusBehaviour.html#c:set_latest_offset/3"},{"type":"callback","title":"Electric.ShapeCache.ShapeStatusBehaviour.set_snapshot_xmin/3","doc":"","ref":"Electric.ShapeCache.ShapeStatusBehaviour.html#c:set_snapshot_xmin/3"},{"type":"callback","title":"Electric.ShapeCache.ShapeStatusBehaviour.snapshot_started?/2","doc":"","ref":"Electric.ShapeCache.ShapeStatusBehaviour.html#c:snapshot_started?/2"},{"type":"type","title":"Electric.ShapeCache.ShapeStatusBehaviour.shape_handle/0","doc":"","ref":"Electric.ShapeCache.ShapeStatusBehaviour.html#t:shape_handle/0"},{"type":"type","title":"Electric.ShapeCache.ShapeStatusBehaviour.xmin/0","doc":"","ref":"Electric.ShapeCache.ShapeStatusBehaviour.html#t:xmin/0"},{"type":"behaviour","title":"Electric.ShapeCache.Storage","doc":"","ref":"Electric.ShapeCache.Storage.html"},{"type":"callback","title":"Electric.ShapeCache.Storage.append_to_log!/2","doc":"Append log items from one transaction to the log.\n\nEach storage implementation is responsible for handling transient errors\nusing some retry strategy.\n\nIf the backend fails to write within the expected time, or some other error\noccurs, then this should raise.","ref":"Electric.ShapeCache.Storage.html#c:append_to_log!/2"},{"type":"function","title":"Electric.ShapeCache.Storage.child_spec/1","doc":"","ref":"Electric.ShapeCache.Storage.html#child_spec/1"},{"type":"callback","title":"Electric.ShapeCache.Storage.cleanup!/1","doc":"Clean up snapshots/logs for a shape handle","ref":"Electric.ShapeCache.Storage.html#c:cleanup!/1"},{"type":"callback","title":"Electric.ShapeCache.Storage.for_shape/2","doc":"Initialise shape-specific opts from the shared, global, configuration","ref":"Electric.ShapeCache.Storage.html#c:for_shape/2"},{"type":"callback","title":"Electric.ShapeCache.Storage.get_all_stored_shapes/1","doc":"Retrieve all stored shapes","ref":"Electric.ShapeCache.Storage.html#c:get_all_stored_shapes/1"},{"type":"callback","title":"Electric.ShapeCache.Storage.get_chunk_end_log_offset/2","doc":"Get the last exclusive offset of the chunk starting from the given offset.\n\nIf chunk has not finished accumulating, `nil` is returned.\n\nIf chunk has finished accumulating, the last offset of the chunk is returned.","ref":"Electric.ShapeCache.Storage.html#c:get_chunk_end_log_offset/2"},{"type":"callback","title":"Electric.ShapeCache.Storage.get_current_position/1","doc":"Get the current xmin and offset for the shape storage.\n\nIf the instance is new, then it MUST return `{LogOffset.first(), nil}`.","ref":"Electric.ShapeCache.Storage.html#c:get_current_position/1"},{"type":"callback","title":"Electric.ShapeCache.Storage.get_log_stream/3","doc":"Get stream of the log for a shape since a given offset","ref":"Electric.ShapeCache.Storage.html#c:get_log_stream/3"},{"type":"callback","title":"Electric.ShapeCache.Storage.get_snapshot/1","doc":"Get the full snapshot for a given shape, also returning the offset this snapshot includes","ref":"Electric.ShapeCache.Storage.html#c:get_snapshot/1"},{"type":"callback","title":"Electric.ShapeCache.Storage.get_total_disk_usage/1","doc":"Get the total disk usage for all shapes","ref":"Electric.ShapeCache.Storage.html#c:get_total_disk_usage/1"},{"type":"callback","title":"Electric.ShapeCache.Storage.initialise/1","doc":"Run any initial setup tasks","ref":"Electric.ShapeCache.Storage.html#c:initialise/1"},{"type":"callback","title":"Electric.ShapeCache.Storage.make_new_snapshot!/2","doc":"Make a new snapshot for a shape handle based on the meta information about the table and a stream of plain string rows\n\nShould raise an error if making the snapshot had failed for any reason.","ref":"Electric.ShapeCache.Storage.html#c:make_new_snapshot!/2"},{"type":"callback","title":"Electric.ShapeCache.Storage.mark_snapshot_as_started/1","doc":"","ref":"Electric.ShapeCache.Storage.html#c:mark_snapshot_as_started/1"},{"type":"callback","title":"Electric.ShapeCache.Storage.set_shape_definition/2","doc":"Store the shape definition","ref":"Electric.ShapeCache.Storage.html#c:set_shape_definition/2"},{"type":"callback","title":"Electric.ShapeCache.Storage.set_snapshot_xmin/2","doc":"","ref":"Electric.ShapeCache.Storage.html#c:set_snapshot_xmin/2"},{"type":"callback","title":"Electric.ShapeCache.Storage.shared_opts/1","doc":"Validate and initialise storage base configuration from application configuration","ref":"Electric.ShapeCache.Storage.html#c:shared_opts/1"},{"type":"callback","title":"Electric.ShapeCache.Storage.snapshot_started?/1","doc":"Check if snapshot for a given shape handle already exists","ref":"Electric.ShapeCache.Storage.html#c:snapshot_started?/1"},{"type":"callback","title":"Electric.ShapeCache.Storage.start_link/1","doc":"Start any processes required to run the storage backend","ref":"Electric.ShapeCache.Storage.html#c:start_link/1"},{"type":"callback","title":"Electric.ShapeCache.Storage.unsafe_cleanup!/1","doc":"Clean up snapshots/logs for a shape handle by deleting whole directory.\n\nDoes not require any extra storage processes to be running, but should only\nbe used if the shape is known to not be in use to avoid concurrency issues.","ref":"Electric.ShapeCache.Storage.html#c:unsafe_cleanup!/1"},{"type":"type","title":"Electric.ShapeCache.Storage.compiled_opts/0","doc":"","ref":"Electric.ShapeCache.Storage.html#t:compiled_opts/0"},{"type":"type","title":"Electric.ShapeCache.Storage.log/0","doc":"","ref":"Electric.ShapeCache.Storage.html#t:log/0"},{"type":"type","title":"Electric.ShapeCache.Storage.log_item/0","doc":"","ref":"Electric.ShapeCache.Storage.html#t:log_item/0"},{"type":"type","title":"Electric.ShapeCache.Storage.offset/0","doc":"","ref":"Electric.ShapeCache.Storage.html#t:offset/0"},{"type":"type","title":"Electric.ShapeCache.Storage.row/0","doc":"","ref":"Electric.ShapeCache.Storage.html#t:row/0"},{"type":"type","title":"Electric.ShapeCache.Storage.shape_handle/0","doc":"","ref":"Electric.ShapeCache.Storage.html#t:shape_handle/0"},{"type":"type","title":"Electric.ShapeCache.Storage.shape_opts/0","doc":"","ref":"Electric.ShapeCache.Storage.html#t:shape_opts/0"},{"type":"type","title":"Electric.ShapeCache.Storage.shape_storage/0","doc":"","ref":"Electric.ShapeCache.Storage.html#t:shape_storage/0"},{"type":"type","title":"Electric.ShapeCache.Storage.storage/0","doc":"","ref":"Electric.ShapeCache.Storage.html#t:storage/0"},{"type":"type","title":"Electric.ShapeCache.Storage.xmin/0","doc":"","ref":"Electric.ShapeCache.Storage.html#t:xmin/0"},{"type":"behaviour","title":"Electric.ShapeCacheBehaviour","doc":"Behaviour defining the ShapeCache functions to be used in mocks","ref":"Electric.ShapeCacheBehaviour.html"},{"type":"callback","title":"Electric.ShapeCacheBehaviour.await_snapshot_start/2","doc":"","ref":"Electric.ShapeCacheBehaviour.html#c:await_snapshot_start/2"},{"type":"callback","title":"Electric.ShapeCacheBehaviour.clean_all_shapes/1","doc":"","ref":"Electric.ShapeCacheBehaviour.html#c:clean_all_shapes/1"},{"type":"callback","title":"Electric.ShapeCacheBehaviour.clean_shape/2","doc":"","ref":"Electric.ShapeCacheBehaviour.html#c:clean_shape/2"},{"type":"callback","title":"Electric.ShapeCacheBehaviour.get_or_create_shape_handle/2","doc":"","ref":"Electric.ShapeCacheBehaviour.html#c:get_or_create_shape_handle/2"},{"type":"callback","title":"Electric.ShapeCacheBehaviour.get_shape/2","doc":"","ref":"Electric.ShapeCacheBehaviour.html#c:get_shape/2"},{"type":"callback","title":"Electric.ShapeCacheBehaviour.handle_truncate/2","doc":"","ref":"Electric.ShapeCacheBehaviour.html#c:handle_truncate/2"},{"type":"callback","title":"Electric.ShapeCacheBehaviour.has_shape?/2","doc":"","ref":"Electric.ShapeCacheBehaviour.html#c:has_shape?/2"},{"type":"callback","title":"Electric.ShapeCacheBehaviour.list_shapes/1","doc":"","ref":"Electric.ShapeCacheBehaviour.html#c:list_shapes/1"},{"type":"callback","title":"Electric.ShapeCacheBehaviour.update_shape_latest_offset/3","doc":"Update a shape's status with a new log offset","ref":"Electric.ShapeCacheBehaviour.html#c:update_shape_latest_offset/3"},{"type":"type","title":"Electric.ShapeCacheBehaviour.shape_def/0","doc":"","ref":"Electric.ShapeCacheBehaviour.html#t:shape_def/0"},{"type":"type","title":"Electric.ShapeCacheBehaviour.shape_handle/0","doc":"","ref":"Electric.ShapeCacheBehaviour.html#t:shape_handle/0"},{"type":"type","title":"Electric.ShapeCacheBehaviour.xmin/0","doc":"","ref":"Electric.ShapeCacheBehaviour.html#t:xmin/0"},{"type":"module","title":"Electric.Shapes","doc":"","ref":"Electric.Shapes.html"},{"type":"function","title":"Electric.Shapes.clean_shape/2","doc":"Clean up all data (meta data and shape log + snapshot) associated with the given shape handle","ref":"Electric.Shapes.html#clean_shape/2"},{"type":"function","title":"Electric.Shapes.clean_shapes/2","doc":"","ref":"Electric.Shapes.html#clean_shapes/2"},{"type":"function","title":"Electric.Shapes.get_chunk_end_log_offset/3","doc":"Get the last exclusive offset of the chunk starting from the given offset\n\nIf `nil` is returned, chunk is not complete and the shape's latest offset should be used","ref":"Electric.Shapes.html#get_chunk_end_log_offset/3"},{"type":"function","title":"Electric.Shapes.get_log_stream/3","doc":"Get stream of the log since a given offset","ref":"Electric.Shapes.html#get_log_stream/3"},{"type":"function","title":"Electric.Shapes.get_or_create_shape_handle/2","doc":"Get or create a shape handle and return it along with the latest offset of the shape","ref":"Electric.Shapes.html#get_or_create_shape_handle/2"},{"type":"function","title":"Electric.Shapes.get_shape/2","doc":"Get the shape that corresponds to this shape definition and return it along with the latest offset of the shape","ref":"Electric.Shapes.html#get_shape/2"},{"type":"function","title":"Electric.Shapes.get_snapshot/2","doc":"Get snapshot for the shape handle","ref":"Electric.Shapes.html#get_snapshot/2"},{"type":"function","title":"Electric.Shapes.has_shape?/2","doc":"Check whether the log has an entry for a given shape handle","ref":"Electric.Shapes.html#has_shape?/2"},{"type":"type","title":"Electric.Shapes.shape_handle/0","doc":"","ref":"Electric.Shapes.html#t:shape_handle/0"},{"type":"module","title":"Electric.Shapes.Consumer","doc":"","ref":"Electric.Shapes.Consumer.html"},{"type":"function","title":"Electric.Shapes.Consumer.handle_call/3","doc":"","ref":"Electric.Shapes.Consumer.html#handle_call/3"},{"type":"function","title":"Electric.Shapes.Consumer.handle_cast/2","doc":"","ref":"Electric.Shapes.Consumer.html#handle_cast/2"},{"type":"function","title":"Electric.Shapes.Consumer.handle_events/3","doc":"","ref":"Electric.Shapes.Consumer.html#handle_events/3"},{"type":"function","title":"Electric.Shapes.Consumer.init/1","doc":"","ref":"Electric.Shapes.Consumer.html#init/1"},{"type":"function","title":"Electric.Shapes.Consumer.initial_state/1","doc":"","ref":"Electric.Shapes.Consumer.html#initial_state/1"},{"type":"function","title":"Electric.Shapes.Consumer.name/1","doc":"","ref":"Electric.Shapes.Consumer.html#name/1"},{"type":"function","title":"Electric.Shapes.Consumer.name/2","doc":"","ref":"Electric.Shapes.Consumer.html#name/2"},{"type":"function","title":"Electric.Shapes.Consumer.start_link/1","doc":"","ref":"Electric.Shapes.Consumer.html#start_link/1"},{"type":"function","title":"Electric.Shapes.Consumer.terminate/2","doc":"","ref":"Electric.Shapes.Consumer.html#terminate/2"},{"type":"function","title":"Electric.Shapes.Consumer.whereis/2","doc":"","ref":"Electric.Shapes.Consumer.html#whereis/2"},{"type":"type","title":"Electric.Shapes.Consumer.log_state/0","doc":"","ref":"Electric.Shapes.Consumer.html#t:log_state/0"},{"type":"module","title":"Electric.Shapes.Consumer.Snapshotter","doc":"","ref":"Electric.Shapes.Consumer.Snapshotter.html"},{"type":"function","title":"Electric.Shapes.Consumer.Snapshotter.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Electric.Shapes.Consumer.Snapshotter.html#child_spec/1"},{"type":"function","title":"Electric.Shapes.Consumer.Snapshotter.handle_continue/2","doc":"","ref":"Electric.Shapes.Consumer.Snapshotter.html#handle_continue/2"},{"type":"function","title":"Electric.Shapes.Consumer.Snapshotter.init/1","doc":"","ref":"Electric.Shapes.Consumer.Snapshotter.html#init/1"},{"type":"function","title":"Electric.Shapes.Consumer.Snapshotter.name/1","doc":"","ref":"Electric.Shapes.Consumer.Snapshotter.html#name/1"},{"type":"function","title":"Electric.Shapes.Consumer.Snapshotter.name/2","doc":"","ref":"Electric.Shapes.Consumer.Snapshotter.html#name/2"},{"type":"function","title":"Electric.Shapes.Consumer.Snapshotter.start_link/1","doc":"","ref":"Electric.Shapes.Consumer.Snapshotter.html#start_link/1"},{"type":"module","title":"Electric.Shapes.ConsumerSupervisor","doc":"","ref":"Electric.Shapes.ConsumerSupervisor.html"},{"type":"function","title":"Electric.Shapes.ConsumerSupervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Electric.Shapes.ConsumerSupervisor.html#child_spec/1"},{"type":"function","title":"Electric.Shapes.ConsumerSupervisor.clean_and_stop/1","doc":"","ref":"Electric.Shapes.ConsumerSupervisor.html#clean_and_stop/1"},{"type":"function","title":"Electric.Shapes.ConsumerSupervisor.init/1","doc":"","ref":"Electric.Shapes.ConsumerSupervisor.html#init/1"},{"type":"function","title":"Electric.Shapes.ConsumerSupervisor.name/1","doc":"","ref":"Electric.Shapes.ConsumerSupervisor.html#name/1"},{"type":"function","title":"Electric.Shapes.ConsumerSupervisor.name/2","doc":"","ref":"Electric.Shapes.ConsumerSupervisor.html#name/2"},{"type":"function","title":"Electric.Shapes.ConsumerSupervisor.start_link/1","doc":"","ref":"Electric.Shapes.ConsumerSupervisor.html#start_link/1"},{"type":"module","title":"Electric.Shapes.Dispatcher","doc":"Dispatches transactions and relations to consumers filtered using `Filter`\nand the consumer's shape.\n\nThe essential behaviour is that the dispatcher only asks the producer for\nmore demand once all relevant subscribers have processed the last message and\nasked for the next.\n\nThis behaviour is subtly different from `GenStage.BroadcastDispatcher` in\nthat events that don't match the consumer's selector do not generate demand.\nWe only wait for the consumers who received the event to ack successful\nprocessing before forwarding demand onto the producer.\n\nThis is not a generalised dispatcher, its behaviour is specialised to our\nrequirements. Demand is always 1 -- consumers MUST only ever ask for a single\nmessage from the producer and the dispatcher MUST only ever receive\n1 message from the producer to dispatch.\n\nThis can be done by subscribing with `max_demand: 1` or using manual demand\nand calling `GenStage.ask(producer, 1)`.","ref":"Electric.Shapes.Dispatcher.html"},{"type":"module","title":"Electric.Shapes.Dispatcher.State","doc":"","ref":"Electric.Shapes.Dispatcher.State.html"},{"type":"module","title":"Electric.Shapes.DynamicConsumerSupervisor","doc":"Responsible for managing shape consumer processes","ref":"Electric.Shapes.DynamicConsumerSupervisor.html"},{"type":"function","title":"Electric.Shapes.DynamicConsumerSupervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Electric.Shapes.DynamicConsumerSupervisor.html#child_spec/1"},{"type":"function","title":"Electric.Shapes.DynamicConsumerSupervisor.name/1","doc":"","ref":"Electric.Shapes.DynamicConsumerSupervisor.html#name/1"},{"type":"function","title":"Electric.Shapes.DynamicConsumerSupervisor.start_link/1","doc":"","ref":"Electric.Shapes.DynamicConsumerSupervisor.html#start_link/1"},{"type":"function","title":"Electric.Shapes.DynamicConsumerSupervisor.start_shape_consumer/2","doc":"","ref":"Electric.Shapes.DynamicConsumerSupervisor.html#start_shape_consumer/2"},{"type":"function","title":"Electric.Shapes.DynamicConsumerSupervisor.stop_shape_consumer/3","doc":"","ref":"Electric.Shapes.DynamicConsumerSupervisor.html#stop_shape_consumer/3"},{"type":"module","title":"Electric.Shapes.Filter","doc":"Responsible for knowing which shapes are affected by a change.\n\n`affected_shapes(filter, change)` will return a set of IDs for the shapes that are affected by the change\nconsidering all the shapes that have been added to the filter using `add_shape/3`.\n\n\nThe `Filter` module keeps track of what tables are referenced by the shapes and changes and delegates\nthe table specific logic to the `Filter.Table` module.","ref":"Electric.Shapes.Filter.html"},{"type":"function","title":"Electric.Shapes.Filter.add_shape/3","doc":"Add a shape for the filter to track.\n\nThe `shape_id` can be any term you like to identify the shape. Whatever you use will be returned\nby `affected_shapes/2` when the shape is affected by a change.","ref":"Electric.Shapes.Filter.html#add_shape/3"},{"type":"function","title":"Electric.Shapes.Filter.affected_shapes/2","doc":"Returns the shape IDs for all shapes that have been added to the filter\nthat are affected by the given change.","ref":"Electric.Shapes.Filter.html#affected_shapes/2"},{"type":"function","title":"Electric.Shapes.Filter.new/0","doc":"","ref":"Electric.Shapes.Filter.html#new/0"},{"type":"function","title":"Electric.Shapes.Filter.remove_shape/2","doc":"Remove a shape from the filter.","ref":"Electric.Shapes.Filter.html#remove_shape/2"},{"type":"type","title":"Electric.Shapes.Filter.shape_id/0","doc":"","ref":"Electric.Shapes.Filter.html#t:shape_id/0"},{"type":"type","title":"Electric.Shapes.Filter.t/0","doc":"","ref":"Electric.Shapes.Filter.html#t:t/0"},{"type":"module","title":"Electric.Shapes.Filter.Index","doc":"Responsible for knowing which shapes are affected by a change to a specific field.\n\nThe `%Table{}` struct contains `values` a map of values for a specific field to shapes that are affected by that field value.\nThis acts as an index for the shapes, providing a fast way to know which shapes have been affected without having to\niterate over all the shapes.\n\nCurrently only `=` operations are indexed.","ref":"Electric.Shapes.Filter.Index.html"},{"type":"function","title":"Electric.Shapes.Filter.Index.add_shape/4","doc":"","ref":"Electric.Shapes.Filter.Index.html#add_shape/4"},{"type":"function","title":"Electric.Shapes.Filter.Index.affected_shapes/3","doc":"","ref":"Electric.Shapes.Filter.Index.html#affected_shapes/3"},{"type":"function","title":"Electric.Shapes.Filter.Index.all_shapes/1","doc":"","ref":"Electric.Shapes.Filter.Index.html#all_shapes/1"},{"type":"function","title":"Electric.Shapes.Filter.Index.empty?/1","doc":"","ref":"Electric.Shapes.Filter.Index.html#empty?/1"},{"type":"function","title":"Electric.Shapes.Filter.Index.new/1","doc":"","ref":"Electric.Shapes.Filter.Index.html#new/1"},{"type":"function","title":"Electric.Shapes.Filter.Index.remove_shape/2","doc":"","ref":"Electric.Shapes.Filter.Index.html#remove_shape/2"},{"type":"module","title":"Electric.Shapes.Filter.Table","doc":"Responsible for knowing which shapes are affected by a change to a specific table.\n\nThe `%Table{}` struct contains `indexes`, a map of indexes for shapes that have been optimised, and `other_shapes` for shapes\nthat have not been optimised. The logic for specific indexes is delegated to the `Filter.Index` module.","ref":"Electric.Shapes.Filter.Table.html"},{"type":"function","title":"Electric.Shapes.Filter.Table.add_shape/2","doc":"","ref":"Electric.Shapes.Filter.Table.html#add_shape/2"},{"type":"function","title":"Electric.Shapes.Filter.Table.affected_shapes/2","doc":"","ref":"Electric.Shapes.Filter.Table.html#affected_shapes/2"},{"type":"function","title":"Electric.Shapes.Filter.Table.all_shapes/1","doc":"","ref":"Electric.Shapes.Filter.Table.html#all_shapes/1"},{"type":"function","title":"Electric.Shapes.Filter.Table.empty?/1","doc":"","ref":"Electric.Shapes.Filter.Table.html#empty?/1"},{"type":"function","title":"Electric.Shapes.Filter.Table.new/0","doc":"","ref":"Electric.Shapes.Filter.Table.html#new/0"},{"type":"function","title":"Electric.Shapes.Filter.Table.remove_shape/2","doc":"","ref":"Electric.Shapes.Filter.Table.html#remove_shape/2"},{"type":"module","title":"Electric.Shapes.Querying","doc":"","ref":"Electric.Shapes.Querying.html"},{"type":"function","title":"Electric.Shapes.Querying.stream_initial_data/2","doc":"Streams the initial data for a shape. Query results are returned as a stream of JSON strings, as prepared on PostgreSQL.","ref":"Electric.Shapes.Querying.html#stream_initial_data/2"},{"type":"type","title":"Electric.Shapes.Querying.json_iodata/0","doc":"","ref":"Electric.Shapes.Querying.html#t:json_iodata/0"},{"type":"type","title":"Electric.Shapes.Querying.json_result_stream/0","doc":"","ref":"Electric.Shapes.Querying.html#t:json_result_stream/0"},{"type":"module","title":"Electric.Shapes.Shape","doc":"Struct describing the requested shape","ref":"Electric.Shapes.Shape.html"},{"type":"function","title":"Electric.Shapes.Shape.affected_tables/1","doc":"List tables that are a part of this shape.","ref":"Electric.Shapes.Shape.html#affected_tables/1"},{"type":"function","title":"Electric.Shapes.Shape.convert_change/2","doc":"Convert a change to be correctly represented within the shape.\n\nNew or deleted changes are either propagated as-is, or filtered out completely.\nUpdates, on the other hand, may be converted to an \"new record\" or a \"deleted record\"\nif the previous/new version of the updated row isn't in the shape.","ref":"Electric.Shapes.Shape.html#convert_change/2"},{"type":"function","title":"Electric.Shapes.Shape.from_json_safe!/1","doc":"","ref":"Electric.Shapes.Shape.html#from_json_safe!/1"},{"type":"function","title":"Electric.Shapes.Shape.generate_id/1","doc":"","ref":"Electric.Shapes.Shape.html#generate_id/1"},{"type":"function","title":"Electric.Shapes.Shape.hash/1","doc":"","ref":"Electric.Shapes.Shape.html#hash/1"},{"type":"function","title":"Electric.Shapes.Shape.is_affected_by_relation_change?/2","doc":"","ref":"Electric.Shapes.Shape.html#is_affected_by_relation_change?/2"},{"type":"function","title":"Electric.Shapes.Shape.new/2","doc":"","ref":"Electric.Shapes.Shape.html#new/2"},{"type":"function","title":"Electric.Shapes.Shape.new!/2","doc":"","ref":"Electric.Shapes.Shape.html#new!/2"},{"type":"function","title":"Electric.Shapes.Shape.pk/2","doc":"","ref":"Electric.Shapes.Shape.html#pk/2"},{"type":"function","title":"Electric.Shapes.Shape.to_json_safe/1","doc":"","ref":"Electric.Shapes.Shape.html#to_json_safe/1"},{"type":"function","title":"Electric.Shapes.Shape.verify_replica/1","doc":"","ref":"Electric.Shapes.Shape.html#verify_replica/1"},{"type":"type","title":"Electric.Shapes.Shape.json_relation/0","doc":"","ref":"Electric.Shapes.Shape.html#t:json_relation/0"},{"type":"type","title":"Electric.Shapes.Shape.json_safe/0","doc":"","ref":"Electric.Shapes.Shape.html#t:json_safe/0"},{"type":"type","title":"Electric.Shapes.Shape.json_table_info/0","doc":"","ref":"Electric.Shapes.Shape.html#t:json_table_info/0"},{"type":"type","title":"Electric.Shapes.Shape.json_table_list/0","doc":"","ref":"Electric.Shapes.Shape.html#t:json_table_list/0"},{"type":"type","title":"Electric.Shapes.Shape.replica/0","doc":"","ref":"Electric.Shapes.Shape.html#t:replica/0"},{"type":"type","title":"Electric.Shapes.Shape.t/0","doc":"","ref":"Electric.Shapes.Shape.html#t:t/0"},{"type":"type","title":"Electric.Shapes.Shape.table_info/0","doc":"","ref":"Electric.Shapes.Shape.html#t:table_info/0"},{"type":"type","title":"Electric.Shapes.Shape.table_with_where_clause/0","doc":"","ref":"Electric.Shapes.Shape.html#t:table_with_where_clause/0"},{"type":"module","title":"Electric.Shapes.WhereClause","doc":"","ref":"Electric.Shapes.WhereClause.html"},{"type":"function","title":"Electric.Shapes.WhereClause.includes_record?/2","doc":"","ref":"Electric.Shapes.WhereClause.html#includes_record?/2"},{"type":"module","title":"Electric.StackSupervisor","doc":"Root supervisor that starts a stack of processes to serve shapes.\n\nFull supervision tree looks roughly like this:\n\nFirst, we start 2 registries, `Electric.ProcessRegistry`, and a registry for shape subscriptions. Both are named using the provided `stack_id` variable.\n\n1. `Electric.Postgres.Inspector.EtsInspector` is started with a pool name as a config option, module that is passed from the base config is __ignored__\n2. `Electric.Connection.Supervisor` takes a LOT of options to configure replication and start the rest of the tree. It starts (3) and then (4) in `rest-for-one` mode\n3. `Electric.Connection.Manager` takes all the connection/replication options and starts the db pool. It goes through the following steps:\n    - start_lock_connection\n    - exclusive_connection_lock_acquired (as a callback from the lock connection)\n    - start_replication_client\n      This starts a replication client (3.1) with no auto-reconnection, because manager is expected to restart this client in case something goes wrong. The streaming of WAL does not start automatically and has to be started explicitly by the manager\n    - start_connection_pool (only if it's not started already, otherwise start streaming)\n      This starts a `Postgrex` connection pool (3.2) to the DB we're going to use. If it's ok, we then do a bunch of checks, then ask (3) to finally start (4), and start streaming\n\n    1. `Electric.Postgres.ReplicationClient` - connects to PG in replication mod, sets up slots, _does not start streaming_ until requested\n    2. `Postgrex` connection pool is started for querying initial snapshots & info about the DB\n4. `Electric.Replication.Supervisor` is a supervisor responsible for taking the replication log from the replication client and shoving it into storage appropriately. It starts 3 things in one-for-all mode:\n    1. `Electric.Shapes.DynamicConsumerSupervisor` is DynamicSupervisor. It oversees a per-shape storage & replication log consumer\n        1. `Electric.Shapes.ConsumerSupervisor` supervises the \"consumer\" part of the replication process, starting 3 children. These are started for each shape.\n            1. `Electric.ShapeCache.Storage` is a process that knows how to write to disk. Takes configuration options for the underlying storage, is an end point\n            2. `Electric.Shapes.Consumer` is GenStage consumer, subscribing to `LogCollector`, which acts a shared producer for all shapes. It passes any incoming operation along to the storage.\n            3. `Electric.Shapes.Consumer.Snapshotter` is a temporary GenServer that executes initial snapshot query and writes that to storage\n    2. `Electric.Replication.ShapeLogCollector` collects transactions from the replication connection, fanning them out to `Electric.Shapes.Consumer` (4.1.1.2)\n    3. `Electric.ShapeCache` coordinates shape creation and handle allocation, shape metadata","ref":"Electric.StackSupervisor.html"},{"type":"function","title":"Electric.StackSupervisor.build_shared_opts/1","doc":"","ref":"Electric.StackSupervisor.html#build_shared_opts/1"},{"type":"function","title":"Electric.StackSupervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Electric.StackSupervisor.html#child_spec/1"},{"type":"function","title":"Electric.StackSupervisor.dispatch_stack_event/3","doc":"","ref":"Electric.StackSupervisor.html#dispatch_stack_event/3"},{"type":"function","title":"Electric.StackSupervisor.start_link/1","doc":"","ref":"Electric.StackSupervisor.html#start_link/1"},{"type":"function","title":"Electric.StackSupervisor.subscribe_to_stack_events/3","doc":"","ref":"Electric.StackSupervisor.html#subscribe_to_stack_events/3"},{"type":"module","title":"Electric.Telemetry","doc":"","ref":"Electric.Telemetry.html"},{"type":"function","title":"Electric.Telemetry.call_home_metrics/0","doc":"","ref":"Electric.Telemetry.html#call_home_metrics/0"},{"type":"function","title":"Electric.Telemetry.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Electric.Telemetry.html#child_spec/1"},{"type":"function","title":"Electric.Telemetry.count_shapes/1","doc":"","ref":"Electric.Telemetry.html#count_shapes/1"},{"type":"function","title":"Electric.Telemetry.get_total_disk_usage/1","doc":"","ref":"Electric.Telemetry.html#get_total_disk_usage/1"},{"type":"function","title":"Electric.Telemetry.init/1","doc":"","ref":"Electric.Telemetry.html#init/1"},{"type":"function","title":"Electric.Telemetry.start_link/1","doc":"","ref":"Electric.Telemetry.html#start_link/1"},{"type":"function","title":"Electric.Telemetry.static_info/0","doc":"","ref":"Electric.Telemetry.html#static_info/0"},{"type":"function","title":"Electric.Telemetry.uptime_event/0","doc":"","ref":"Electric.Telemetry.html#uptime_event/0"},{"type":"module","title":"Electric.Telemetry.CallHomeReporter","doc":"Reporter that collects runtime telemetry information and sends it to a configured\nhome server once in a while. The information is aggregated over a period of time,\nwith percentile values calculated for the metrics that have them.","ref":"Electric.Telemetry.CallHomeReporter.html"},{"type":"function","title":"Electric.Telemetry.CallHomeReporter.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Electric.Telemetry.CallHomeReporter.html#child_spec/1"},{"type":"function","title":"Electric.Telemetry.CallHomeReporter.deep_merge/2","doc":"","ref":"Electric.Telemetry.CallHomeReporter.html#deep_merge/2"},{"type":"function","title":"Electric.Telemetry.CallHomeReporter.handle_event/4","doc":"","ref":"Electric.Telemetry.CallHomeReporter.html#handle_event/4"},{"type":"function","title":"Electric.Telemetry.CallHomeReporter.print_stats/1","doc":"","ref":"Electric.Telemetry.CallHomeReporter.html#print_stats/1"},{"type":"function","title":"Electric.Telemetry.CallHomeReporter.report_home/1","doc":"","ref":"Electric.Telemetry.CallHomeReporter.html#report_home/1"},{"type":"function","title":"Electric.Telemetry.CallHomeReporter.start_link/1","doc":"","ref":"Electric.Telemetry.CallHomeReporter.html#start_link/1"},{"type":"type","title":"Electric.Telemetry.CallHomeReporter.metric/0","doc":"","ref":"Electric.Telemetry.CallHomeReporter.html#t:metric/0"},{"type":"type","title":"Electric.Telemetry.CallHomeReporter.report_format/0","doc":"","ref":"Electric.Telemetry.CallHomeReporter.html#t:report_format/0"},{"type":"module","title":"Electric.Telemetry.OpenTelemetry","doc":"This module implements an API to cover parts of the code with tracing spans that are then\nexported using the OpenTelemetry protocol.\n\n[OpenTelemetry][1] is an observability framework that is widely supported by observability tools.\n\nThis module's implementation is based on the [opentelemetry-erlang][2] suite of libraries.\nThere is a rudimentary Elixir API there but it's incomplete and non-idiomatic. The idea with\nthis module is to expose all of the functionality we're using in our code by wrapping\nopentelemetry-erlang's API.\n\nThe configuration for OpenTelemetry export is located in `config/runtime.exs`.\n\nThe API implemented here so far includes support for:\n\n  - Defining a span to cover the execution of a piece of code. See `with_span/3`.\n\n  - Propagating span context across Elixir processes, to allow for a span started in one\n    process to be registered as a parent of a span started in a different process. See\n    `async_fun/4`.\n\n  - Adding dynamic attributes to the current span, after it has already started. See\n    `add_span_attributes/2`.\n\n  - Recording an error or an exception as a span event. See `record_exception/4`.\n\n[1]: https://opentelemetry.io/docs/what-is-opentelemetry/\n[2]: https://github.com/open-telemetry/opentelemetry-erlang","ref":"Electric.Telemetry.OpenTelemetry.html"},{"type":"function","title":"Electric.Telemetry.OpenTelemetry.add_span_attributes/2","doc":"Add dynamic attributes to the current span.\n\nFor example, if a span is started prior to issuing a DB request, an attribute named\n`num_rows_fetched` can be added to it using this function once the DB query returns its\nresult.","ref":"Electric.Telemetry.OpenTelemetry.html#add_span_attributes/2"},{"type":"function","title":"Electric.Telemetry.OpenTelemetry.async_fun/4","doc":"Wrap the given `fun` in an anonymous function, attaching the current process' span context to it.\n\nIf the wrapped function starts a new span in a different Elixir process, the attached span\ncontext will be used to establish the parent-child relationship between spans across the\nprocess boundary.","ref":"Electric.Telemetry.OpenTelemetry.html#async_fun/4"},{"type":"function","title":"Electric.Telemetry.OpenTelemetry.get_current_context/0","doc":"","ref":"Electric.Telemetry.OpenTelemetry.html#get_current_context/0"},{"type":"function","title":"Electric.Telemetry.OpenTelemetry.record_exception/2","doc":"Add an error event to the current span.","ref":"Electric.Telemetry.OpenTelemetry.html#record_exception/2"},{"type":"function","title":"Electric.Telemetry.OpenTelemetry.record_exception/4","doc":"","ref":"Electric.Telemetry.OpenTelemetry.html#record_exception/4"},{"type":"function","title":"Electric.Telemetry.OpenTelemetry.set_current_context/1","doc":"","ref":"Electric.Telemetry.OpenTelemetry.html#set_current_context/1"},{"type":"function","title":"Electric.Telemetry.OpenTelemetry.timed_fun/3","doc":"Executes the provided function and records its duration in microseconds.\nThe duration is added to the current span as a span attribute named with the given `name`.","ref":"Electric.Telemetry.OpenTelemetry.html#timed_fun/3"},{"type":"function","title":"Electric.Telemetry.OpenTelemetry.with_span/3","doc":"Create a span that starts at the current point in time and ends when `fun` returns.\n\nReturns the result of calling the function `fun`.\n\nCalling this function inside another span establishes a parent-child relationship between\nthe two, as long as both calls happen within the same Elixir process. See `async_fun/4` for\ninterprocess progragation of span context.","ref":"Electric.Telemetry.OpenTelemetry.html#with_span/3"},{"type":"module","title":"Electric.Telemetry.Sampler","doc":"Custom sampler that samples all spans except for specifically configured spans for which a given ratio is sampled.","ref":"Electric.Telemetry.Sampler.html"},{"type":"module","title":"Electric.Timeline","doc":"Module exporting functions for handling Postgres timelines.\nVerifies the Postgres ID and its timeline.","ref":"Electric.Timeline.html"},{"type":"function","title":"Electric.Timeline.check/2","doc":"Checks that we're connected to the same Postgres DB as before and on the same timeline.\nTO this end, it checks the provided `pg_id` against the persisted PG ID.\nIf the PG IDs match, it also checks the provided `pg_timeline` against the persisted timeline.\nNormally, Postgres and Electric are on the same timeline and nothing must be done.\nIf the timelines differ, that indicates that a Point In Time Recovery (PITR) has occurred and all shapes must be cleaned.\nIf we fail to fetch timeline information, we also clean all shapes for safety as we can't be sure that Postgres and Electric are on the same timeline.","ref":"Electric.Timeline.html#check/2"},{"type":"function","title":"Electric.Timeline.load_timeline/1","doc":"","ref":"Electric.Timeline.html#load_timeline/1"},{"type":"function","title":"Electric.Timeline.store_timeline/2","doc":"","ref":"Electric.Timeline.html#store_timeline/2"},{"type":"type","title":"Electric.Timeline.check_result/0","doc":"","ref":"Electric.Timeline.html#t:check_result/0"},{"type":"type","title":"Electric.Timeline.pg_id/0","doc":"","ref":"Electric.Timeline.html#t:pg_id/0"},{"type":"type","title":"Electric.Timeline.timeline/0","doc":"","ref":"Electric.Timeline.html#t:timeline/0"},{"type":"type","title":"Electric.Timeline.timeline_id/0","doc":"","ref":"Electric.Timeline.html#t:timeline_id/0"},{"type":"module","title":"Electric.Utils","doc":"","ref":"Electric.Utils.html"},{"type":"function","title":"Electric.Utils.all_max_by/5","doc":"Return a list of values from `enum` that are the maximal elements as calculated\nby the given `fun`.\n\nBase behaviour is similar to `Enum.max_by/4`, but this function returns a list\nof all maximal values instead of just the first one.","ref":"Electric.Utils.html#all_max_by/5"},{"type":"function","title":"Examples - Electric.Utils.all_max_by/5","doc":"iex> all_max_by([4, 1, 1, 3, -4], &abs/1)\n    [4, -4]\n\n    iex> all_max_by([4, 1, -1, 3, 4], &abs/1, &<=/2)\n    [1, -1]\n\n    iex> all_max_by([], &abs/1)\n    ** (Enum.EmptyError) empty error","ref":"Electric.Utils.html#all_max_by/5-examples"},{"type":"function","title":"Electric.Utils.apply_fn_or_mfa/2","doc":"Applies either an anonymous function or a MFA tuple, prepending the given arguments\nin case of an MFA.","ref":"Electric.Utils.html#apply_fn_or_mfa/2"},{"type":"function","title":"Examples - Electric.Utils.apply_fn_or_mfa/2","doc":"iex> apply_fn_or_mfa(&String.contains?(&1, \"foo\"), [\"foobar\"])\n    true\n\n    iex> apply_fn_or_mfa({String, :contains?, [\"foo\"]}, [\"foobar\"])\n    true","ref":"Electric.Utils.html#apply_fn_or_mfa/2-examples"},{"type":"function","title":"Electric.Utils.deep_map/2","doc":"Apply a function to each element of an enumerable, recursively if the element is an enumerable itself.","ref":"Electric.Utils.html#deep_map/2"},{"type":"function","title":"Examples - Electric.Utils.deep_map/2","doc":"iex> deep_map([1, [2, [3]], 4], &(&1 * 2))\n    [2, [4, [6]], 8]","ref":"Electric.Utils.html#deep_map/2-examples"},{"type":"function","title":"Electric.Utils.deobfuscate_password/1","doc":"Undo the obfuscation applied by `obfuscate_password/1`.\n\nThis function should be called just before passing connection options to one of\n`Postgrex` functions. Never store deobfuscated password in any of our process\nstates.","ref":"Electric.Utils.html#deobfuscate_password/1"},{"type":"function","title":"Electric.Utils.encode_uuid/1","doc":"Encode binary representation of a UUID into a string","ref":"Electric.Utils.html#encode_uuid/1"},{"type":"function","title":"Examples - Electric.Utils.encode_uuid/1","doc":"iex> encode_uuid(<<1, 35, 69, 103, 137, 171, 76, 222, 143, 227, 251, 149, 223, 249, 31, 215>>)\n    \"01234567-89ab-4cde-8fe3-fb95dff91fd7\"","ref":"Electric.Utils.html#encode_uuid/1-examples"},{"type":"function","title":"Electric.Utils.escape_quotes/1","doc":"","ref":"Electric.Utils.html#escape_quotes/1"},{"type":"function","title":"Electric.Utils.inspect_relation/1","doc":"Output a 2-tuple relation (table) reference as pg-style `\"schema\".\"table\"`.","ref":"Electric.Utils.html#inspect_relation/1"},{"type":"function","title":"Examples - Electric.Utils.inspect_relation/1","doc":"iex> inspect_relation({\"schema\", \"table\"})\n    ~S|\"schema\".\"table\"|","ref":"Electric.Utils.html#inspect_relation/1-examples"},{"type":"function","title":"Electric.Utils.map_values/2","doc":"Apply a function to each value of a map.","ref":"Electric.Utils.html#map_values/2"},{"type":"function","title":"Electric.Utils.map_while_ok/2","doc":"Map each value of the enumerable using a mapper, unwrapping a result tuple returned by\nthe mapper and stopping on error.","ref":"Electric.Utils.html#map_while_ok/2"},{"type":"function","title":"Examples - Electric.Utils.map_while_ok/2","doc":"iex> map_while_ok([\"2015-01-23 23:50:07.0\", \"2015-01-23 23:50:08\"], &NaiveDateTime.from_iso8601/1)\n    {:ok, [~N[2015-01-23 23:50:07.0], ~N[2015-01-23 23:50:08]]}\n\n    iex> map_while_ok([\"2015-01-23 23:50:07A\", \"2015-01-23 23:50:08\"], &NaiveDateTime.from_iso8601/1)\n    {:error, :invalid_format}","ref":"Electric.Utils.html#map_while_ok/2-examples"},{"type":"function","title":"Electric.Utils.obfuscate_password/1","doc":"Given a keyword list of database connection options, obfuscate the password by wrapping it in\na zero-arity function.\n\nThis should be done as early as possible when parsing connection options from the OS env. The\naim of this obfuscation is to avoid accidentally leaking the password when inspecting connection\nopts or logging them as part of a process state (which is done automatically by OTP when a\nprocess that implements an OTP behaviour crashes).","ref":"Electric.Utils.html#obfuscate_password/1"},{"type":"function","title":"Electric.Utils.parse_md_table/2","doc":"Parse a markdown table from a string\n\nOptions:\n- `after:` - taking a first table that comes right after a given substring.","ref":"Electric.Utils.html#parse_md_table/2"},{"type":"function","title":"Example - Electric.Utils.parse_md_table/2","doc":"iex> \"\"\"\n    ...> Some text\n    ...>\n    ...>","ref":"Electric.Utils.html#parse_md_table/2-example"},{"type":"function","title":"Known types - Electric.Utils.parse_md_table/2","doc":"...>\n    ...> | type                    | category | preferred? |\n    ...> | ----------------------- | -------- | ---------- |\n    ...> | bool                    | boolean  | t          |\n    ...> | int2                    | numeric  |            |\n    ...> \"\"\"|> parse_md_table(after: \"","ref":"Electric.Utils.html#parse_md_table/2-known-types"},{"type":"function","title":"Known types\") - Electric.Utils.parse_md_table/2","doc":"[[\"bool\", \"boolean\", \"t\"], [\"int2\", \"numeric\", \"\"]]\n\n    iex> \"\"\"\n    ...> Some text\n    ...> \"\"\"|> parse_md_table([])\n    []","ref":"Electric.Utils.html#parse_md_table/2-known-types"},{"type":"function","title":"Electric.Utils.parse_quoted_name/1","doc":"Parses quoted names.\nLowercases unquoted names to match Postgres' case insensitivity.","ref":"Electric.Utils.html#parse_quoted_name/1"},{"type":"function","title":"Examples - Electric.Utils.parse_quoted_name/1","doc":"iex> parse_quoted_name(\"foo\")\n    \"foo\"\n\n    iex> parse_quoted_name(~S|\"foo\"|)\n    \"foo\"\n\n    iex> parse_quoted_name(~S|\"fo\"\"o\"|)\n    ~S|fo\"o|\n\n    iex> parse_quoted_name(~S|\"FooBar\"|)\n    ~S|FooBar|\n\n    iex> parse_quoted_name(~S|FooBar|)\n    ~S|FooBar|","ref":"Electric.Utils.html#parse_quoted_name/1-examples"},{"type":"function","title":"Electric.Utils.quote_name/1","doc":"Quote a string for use in SQL queries.","ref":"Electric.Utils.html#quote_name/1"},{"type":"function","title":"Examples - Electric.Utils.quote_name/1","doc":"iex> quote_name(\"foo\")\n    ~S|\"foo\"|\n\n    iex> quote_name(~S|fo\"o|)\n    ~S|\"fo\"\"o\"|","ref":"Electric.Utils.html#quote_name/1-examples"},{"type":"function","title":"Electric.Utils.relation_to_sql/1","doc":"Format a relation tuple to be correctly escaped for use in SQL queries.","ref":"Electric.Utils.html#relation_to_sql/1"},{"type":"function","title":"Examples - Electric.Utils.relation_to_sql/1","doc":"iex> relation_to_sql({\"public\", \"items\"})\n    ~S|\"public\".\"items\"|\n\n    iex> relation_to_sql({\"with spaces\", ~S|and \"quoted\"!|})\n    ~S|\"with spaces\".\"and \"\"quoted\"\"!\"|","ref":"Electric.Utils.html#relation_to_sql/1-examples"},{"type":"function","title":"Electric.Utils.uuid4/0","doc":"Generate a random UUID v4.\n\nCode taken from Ecto: https://github.com/elixir-ecto/ecto/blob/v3.10.2/lib/ecto/uuid.ex#L174","ref":"Electric.Utils.html#uuid4/0"},{"type":"function","title":"Examples - Electric.Utils.uuid4/0","doc":"iex> Regex.match?(~r/^[0-9a-f]{8}-[0-9a-f]{4}-4[0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}$/, uuid4())\n    true","ref":"Electric.Utils.html#uuid4/0-examples"},{"type":"module","title":"PgInterop.Array","doc":"","ref":"PgInterop.Array.html"},{"type":"function","title":"PgInterop.Array.array_append/2","doc":"","ref":"PgInterop.Array.html#array_append/2"},{"type":"function","title":"PgInterop.Array.array_prepend/2","doc":"","ref":"PgInterop.Array.html#array_prepend/2"},{"type":"function","title":"PgInterop.Array.concat_arrays/2","doc":"","ref":"PgInterop.Array.html#concat_arrays/2"},{"type":"function","title":"PgInterop.Array.get_array_dim/2","doc":"Get the dimension of a postgres array.","ref":"PgInterop.Array.html#get_array_dim/2"},{"type":"function","title":"Examples - PgInterop.Array.get_array_dim/2","doc":"iex> ~S|{}| |> parse() |> get_array_dim()\n    nil\n\n    iex> ~S|{1,2,3,4,5}| |> parse() |> get_array_dim()\n    1\n\n    iex> ~S|{{1,2},{3,4}}| |> parse() |> get_array_dim()\n    2","ref":"PgInterop.Array.html#get_array_dim/2-examples"},{"type":"function","title":"PgInterop.Array.index_access/2","doc":"Access an index of a postgres array. If the index is out of bounds or array has more dimensions than the indices provided, returns `nil`.","ref":"PgInterop.Array.html#index_access/2"},{"type":"function","title":"Examples - PgInterop.Array.index_access/2","doc":"iex> ~S|{1,2,3,4,5}| |> parse(&String.to_integer/1) |> index_access([{:index, 3}])\n    3\n\n    iex> ~S|{{1,2},{3,4}}| |> parse(&String.to_integer/1) |> index_access([{:index, 2}, {:index, 1}])\n    3\n\n    iex> ~S|{{1,2},{3,4}}| |> parse(&String.to_integer/1) |> index_access([{:index, 3}])\n    nil","ref":"PgInterop.Array.html#index_access/2-examples"},{"type":"function","title":"PgInterop.Array.parse/2","doc":"Parse a Postgres string-serialized array into a list of strings, unwrapping the escapes. Parses nested arrays.\nIf a casting function is provided, it will be applied to each element.\n\nParsing follows SOME of the same rules as the postgres parser, in particular:\n1. at most 6 nesting levels are allowed,\n2. arrays must be of uniform dimension, i.e. all sub-arrays must have the same number of elements if at the same depth.\n\nThis implementation also breaks away from the postgres parser in that some bugs are NOT reimplemented:\n- `select '{{1},{{2}}}'::text[];` yields `{{{1}},{{2}}}` in PG, we raise an error\n- `select '{{{1}},{2}}'::text[];` yields `{}` in PG, we raise an error\n- `select '{{{1}},{2},{{3}}}::text[];` yields `{{{1}},{{NULL}},{{3}}}` in PG, we raise an error","ref":"PgInterop.Array.html#parse/2"},{"type":"function","title":"Examples - PgInterop.Array.parse/2","doc":"iex> ~S|{\"(\\\"2023-06-15 11:18:05.372698+00\\\",)\"}| |> parse()\n    [~s|(\"2023-06-15 11:18:05.372698+00\",)|]\n\n    iex> ~S|{\"(\\\"2023-06-15 11:18:05.372698+00\\\",)\",\"(\\\"2023-06-15 11:18:05.372698+00\\\",)\"}| |> parse()\n    [~s|(\"2023-06-15 11:18:05.372698+00\",)|, ~s|(\"2023-06-15 11:18:05.372698+00\",)|]\n\n    iex> ~S|{hello, world, null, \"null\"}| |> parse()\n    [\"hello\", \"world\", nil, \"null\"]\n\n    iex> ~S|{\"2023-06-15 11:18:05.372698+00\",2023-06-15 11:18:05.372698+00}| |> parse(fn x -> {:ok, n, _} = DateTime.from_iso8601(x); n end)\n    [~U[2023-06-15 11:18:05.372698Z], ~U[2023-06-15 11:18:05.372698Z]]\n\n    iex> ~s|{ \"1\" , 3  ,   \"2\" ,    3 3  }| |> parse()\n    [\"1\", \"3\", \"2\", \"3 3\"]\n\n    iex> ~s|{ {{1, 1}, { \"2\"   , 2 }} ,{{\"3\", 3}, {4, 4} }, {  {5, 5},{6, 6}  }}| |> parse(&String.to_integer/1)\n    [[[1, 1], [2, 2]], [[3, 3], [4, 4]], [[5, 5], [6, 6]]]\n\n    iex> ~s|{ \"1\" ,   \"2\" ,    3 3   , , 4}| |> parse()\n    ** (RuntimeError) Unexpected ',' character\n\n    iex> ~s|{ \"1\" , 3,  \"2\" ,    3 3   , }| |> parse()\n    ** (RuntimeError) Unexpected '}' character\n\n    iex> ~s|{ {1} ,{   2 }, {3  }}  }| |> parse()\n    ** (RuntimeError) Invalid array syntax\n\n    iex> ~s|{{{1} ,{   2 }, {3  }} | |> parse()\n    ** (RuntimeError) Unexpected end of input\n\n    iex> ~s|{\"}| |> parse()\n    ** (RuntimeError) Unexpected end of input\n\n    iex> ~s|{{1},2,{3}}| |> parse(&String.to_integer/1)\n    ** (RuntimeError) Unexpected array element\n\n    iex> ~s|{{{{{{{1}}}}}}}| |> parse()\n    ** (RuntimeError) number of dimensions (7) exceeds maximum of 6\n\n    iex> ~s|{ {1} ,{   {2} }, {3  }}| |> parse()\n    ** (RuntimeError) Inconsistent array dimensions\n\n    iex> ~s|{ {{1}} ,{2}, {3  }}| |> parse()\n    ** (RuntimeError) Inconsistent array dimensions","ref":"PgInterop.Array.html#parse/2-examples"},{"type":"function","title":"PgInterop.Array.serialize/2","doc":"Serialize a list of strings into a postgres string-serialized array into a list of strings, wrapping the contents","ref":"PgInterop.Array.html#serialize/2"},{"type":"function","title":"Examples - PgInterop.Array.serialize/2","doc":"iex> [~s|(\"2023-06-15 11:18:05.372698+00\",)|] |> serialize()\n    ~S|{\"(\\\"2023-06-15 11:18:05.372698+00\\\",)\"}|\n\n    iex> [~s|(\"2023-06-15 11:18:05.372698+00\",)|, ~s|(\"2023-06-15 11:18:05.372698+00\",)|] |> serialize()\n    ~S|{\"(\\\"2023-06-15 11:18:05.372698+00\\\",)\",\"(\\\"2023-06-15 11:18:05.372698+00\\\",)\"}|\n\n    iex> str = ~S|{\"(\\\"2023-06-15 11:18:05.372698+00\\\",)\",\"(\\\"2023-06-15 11:18:05.372698+00\\\",)\"}|\n    iex> str |> parse() |> serialize()\n    str","ref":"PgInterop.Array.html#serialize/2-examples"},{"type":"function","title":"PgInterop.Array.slice_access/2","doc":"Access a slice or index of a postgres array.","ref":"PgInterop.Array.html#slice_access/2"},{"type":"function","title":"Examples - PgInterop.Array.slice_access/2","doc":"iex> ~S|{1,2,3,4,5}| |> parse(&String.to_integer/1) |> slice_access([{:slice, nil, 3}])\n    [1, 2, 3]\n\n    iex> ~S|{1,2,3,4,5}| |> parse(&String.to_integer/1) |> slice_access([{:slice, 3, nil}])\n    [3, 4, 5]\n\n    iex> ~S|{1,2,3,4,5}| |> parse(&String.to_integer/1) |> slice_access([{:slice, 3, 4}])\n    [3, 4]\n\n    iex> ~S|{{1,2},{3,4}}| |> parse(&String.to_integer/1) |> slice_access([{:slice, nil, nil}, {:index, 2}])\n    [[1, 2], [3, 4]]\n\n    iex> ~S|{{1,2},{3,4}}| |> parse(&String.to_integer/1) |> slice_access([{:slice, nil, nil}, {:slice, 2, 2}])\n    [[2], [4]]\n\n    iex> ~S|{{1,2},{3,4}}| |> parse(&String.to_integer/1) |> slice_access([{:slice, nil, nil}, {:slice, -1, 1}])\n    [[1], [3]]\n\n    iex> ~S|{{1,2},{3,4}}| |> parse(&String.to_integer/1) |> slice_access([{:slice, nil, nil}, {:slice, 1, -1}])\n    []","ref":"PgInterop.Array.html#slice_access/2-examples"},{"type":"module","title":"PgInterop.Interval","doc":"PostgreSQL interval representation.\n\n`Timex.Duration` does not match PG interval representation because it doesn't store month\nseparately, leading to discrepancies like `date '2024-01-31' + interval '1 month'` being\n`datetime '2024-02-29 00:00:00` in Postgres, but `Timex.add(~N[2024-01-31 00:00:00],\nTimex.Duration.parse!(\"P1M\"))` being `~N[2024-03-01 00:00:00]`. This implementation\nsticks to PG interpretation of the events.","ref":"PgInterop.Interval.html"},{"type":"function","title":"PgInterop.Interval.add/2","doc":"Add two intervals together","ref":"PgInterop.Interval.html#add/2"},{"type":"function","title":"PgInterop.Interval.add_to_date/2","doc":"Add the interval to a given `Date` or `NaiveDateTime`.","ref":"PgInterop.Interval.html#add_to_date/2"},{"type":"function","title":"Examples - PgInterop.Interval.add_to_date/2","doc":"iex> add_to_date(~D[2024-01-01], parse!(\"P1D\"))\n    ~N[2024-01-02 00:00:00]\n\n    iex> add_to_date(~N[2024-01-01 12:00:00], parse!(\"P1DT10M\"))\n    ~N[2024-01-02 12:10:00.000000]","ref":"PgInterop.Interval.html#add_to_date/2-examples"},{"type":"function","title":"PgInterop.Interval.add_to_time/2","doc":"Add the interval to a given `Date` or `NaiveDateTime`.","ref":"PgInterop.Interval.html#add_to_time/2"},{"type":"function","title":"Examples - PgInterop.Interval.add_to_time/2","doc":"iex> add_to_time(~T[10:00:00], parse!(\"PT1H1M\"))\n    ~T[11:01:00.000000]","ref":"PgInterop.Interval.html#add_to_time/2-examples"},{"type":"function","title":"PgInterop.Interval.datetime_diff/2","doc":"Build an interval as a difference between DateTimes. Interval is positive when\nfirst datetime is greater than the second one.","ref":"PgInterop.Interval.html#datetime_diff/2"},{"type":"function","title":"Examples - PgInterop.Interval.datetime_diff/2","doc":"iex> datetime_diff(~N[2024-01-02 00:10:00], ~N[2024-01-01 00:00:00])\n    Interval.parse!(\"P1DT10M\")\n\n    iex> datetime_diff(~N[2024-01-02 00:00:00], ~N[2024-01-01 00:10:00])\n    Interval.parse!(\"PT23H50M\")\n\n    iex> datetime_diff(~N[2024-01-02 00:00:00], ~N[2024-01-03 00:00:00])\n    Interval.parse!(\"P-1D\")\n\n    iex> datetime_diff(DateTime.from_naive!(~N[2024-01-02 00:00:00], \"Europe/Istanbul\"), ~U[2024-01-02 00:00:00Z])\n    Interval.parse!(\"PT-3H\")","ref":"PgInterop.Interval.html#datetime_diff/2-examples"},{"type":"function","title":"PgInterop.Interval.format/1","doc":"Format the interval in ISO8601 format.","ref":"PgInterop.Interval.html#format/1"},{"type":"function","title":"Examples - PgInterop.Interval.format/1","doc":"iex> parse!(\"5 minutes 3d 4 hours 6\") |> format()\n    \"P3DT4H5M6S\"","ref":"PgInterop.Interval.html#format/1-examples"},{"type":"function","title":"PgInterop.Interval.from_days/1","doc":"Create an interval from specified amount of days.","ref":"PgInterop.Interval.html#from_days/1"},{"type":"function","title":"Examples - PgInterop.Interval.from_days/1","doc":"iex> from_days(10)\n    Interval.parse!(\"P10D\")\n\n    iex> from_days(10.5)\n    Interval.parse!(\"P10DT12H\")","ref":"PgInterop.Interval.html#from_days/1-examples"},{"type":"function","title":"PgInterop.Interval.from_hours/1","doc":"Create an interval from specified amount of hours.","ref":"PgInterop.Interval.html#from_hours/1"},{"type":"function","title":"Examples - PgInterop.Interval.from_hours/1","doc":"iex> from_hours(10)\n    Interval.parse!(\"PT10H\")","ref":"PgInterop.Interval.html#from_hours/1-examples"},{"type":"function","title":"PgInterop.Interval.from_microseconds/1","doc":"Create an interval from specified amount of microseconds.","ref":"PgInterop.Interval.html#from_microseconds/1"},{"type":"function","title":"Examples - PgInterop.Interval.from_microseconds/1","doc":"iex> from_microseconds(1_000_000)\n    Interval.parse!(\"PT1S\")","ref":"PgInterop.Interval.html#from_microseconds/1-examples"},{"type":"function","title":"PgInterop.Interval.from_milliseconds/1","doc":"Create an interval from specified amount of milliseconds.","ref":"PgInterop.Interval.html#from_milliseconds/1"},{"type":"function","title":"Examples - PgInterop.Interval.from_milliseconds/1","doc":"iex> from_milliseconds(1_000)\n    Interval.parse!(\"PT1S\")","ref":"PgInterop.Interval.html#from_milliseconds/1-examples"},{"type":"function","title":"PgInterop.Interval.from_minutes/1","doc":"Create an interval from specified amount of minutes.","ref":"PgInterop.Interval.html#from_minutes/1"},{"type":"function","title":"Examples - PgInterop.Interval.from_minutes/1","doc":"iex> from_minutes(60.5)\n    Interval.parse!(\"PT1H30S\")","ref":"PgInterop.Interval.html#from_minutes/1-examples"},{"type":"function","title":"PgInterop.Interval.from_months/1","doc":"Create an interval from specified amount of months. Fractional\nmonths are counted as parts of 30 days.","ref":"PgInterop.Interval.html#from_months/1"},{"type":"function","title":"Examples - PgInterop.Interval.from_months/1","doc":"iex> from_months(14.5)\n    Interval.parse!(\"P1Y2M15D\")","ref":"PgInterop.Interval.html#from_months/1-examples"},{"type":"function","title":"PgInterop.Interval.from_seconds/1","doc":"Create an interval from specified amount of seconds.","ref":"PgInterop.Interval.html#from_seconds/1"},{"type":"function","title":"Examples - PgInterop.Interval.from_seconds/1","doc":"iex> from_seconds(60)\n    Interval.parse!(\"PT1M\")","ref":"PgInterop.Interval.html#from_seconds/1-examples"},{"type":"function","title":"PgInterop.Interval.from_time/1","doc":"Create an interval from a time instance.","ref":"PgInterop.Interval.html#from_time/1"},{"type":"function","title":"Examples - PgInterop.Interval.from_time/1","doc":"iex> from_time(~T[12:30:40.1])\n    Interval.parse!(\"PT12H30M40.1S\")\n\n    iex> from_time(~T[12:30:40.000001])\n    Interval.parse!(\"PT12H30M40.000001S\")","ref":"PgInterop.Interval.html#from_time/1-examples"},{"type":"function","title":"PgInterop.Interval.from_weeks/1","doc":"Create an interval from specified amount of weeks.","ref":"PgInterop.Interval.html#from_weeks/1"},{"type":"function","title":"Examples - PgInterop.Interval.from_weeks/1","doc":"iex> from_weeks(4.2)\n    Interval.parse!(\"P29DT9H36M\")","ref":"PgInterop.Interval.html#from_weeks/1-examples"},{"type":"function","title":"PgInterop.Interval.justify_days/1","doc":"Move complete 30 day periods from the day portion of the interval to the month portion.","ref":"PgInterop.Interval.html#justify_days/1"},{"type":"function","title":"PgInterop.Interval.justify_hours/1","doc":"Move complete 24 hour periods from the microsecond portion of the interval to the day portion.","ref":"PgInterop.Interval.html#justify_hours/1"},{"type":"function","title":"PgInterop.Interval.justify_interval/1","doc":"Move complete 24 hour periods from the microsecond portion of the interval to the day portion\nand complete 30 day periods from the day portion of the interval to the month portion.","ref":"PgInterop.Interval.html#justify_interval/1"},{"type":"function","title":"Examples - PgInterop.Interval.justify_interval/1","doc":"iex> interval = %Interval{months: 0, days: 29, microseconds: 86400000000 + 60_000_000}\n    Interval.parse!(\"P29DT24H1M\")\n    iex> justify_interval(interval)\n    Interval.parse!(\"P1MT1M\")","ref":"PgInterop.Interval.html#justify_interval/1-examples"},{"type":"function","title":"PgInterop.Interval.parse/1","doc":"Parse a PostgreSQL interval string, in any of the supported PostgreSQL input formats.\n\nFor supported formats, see `parse!/1`","ref":"PgInterop.Interval.html#parse/1"},{"type":"function","title":"PgInterop.Interval.parse!/1","doc":"Parse a PostgreSQL interval string, in any of the supported PostgreSQL input formats.\n\nRaises an error when parsing fails, unlike `parse/1`","ref":"PgInterop.Interval.html#parse!/1"},{"type":"function","title":"Examples - PgInterop.Interval.parse!/1","doc":"SQL standard format\n\n    iex> parse!(\"1-2\")\n    Interval.parse!(\"P1Y2M\")\n    iex> parse!(\"3 4:05:06\")\n    Interval.parse!(\"P3DT4H5M6S\")\n\n    iex> parse!(\"5 minutes 3d 4 hours 6\")\n    Interval.parse!(\"P3DT4H5M6S\")\n\nISO8601 format\n\n    iex> parse!(\"P1Y2M3DT4H5M6S\")\n    Interval.parse!(\"P1Y2M3DT4H5M6S\")\n\nISO8601 \"alternative\" format\n\n    iex> parse!(\"P0001-02-03T04:05:06\")\n    Interval.parse!(\"P1Y2M3DT4H5M6S\")\n\n    iex> parse!(\"what\")\n    ** (RuntimeError) Not a valid PostgreSQL interval","ref":"PgInterop.Interval.html#parse!/1-examples"},{"type":"function","title":"PgInterop.Interval.scale/2","doc":"Scale an interval by a factor.","ref":"PgInterop.Interval.html#scale/2"},{"type":"function","title":"Examples - PgInterop.Interval.scale/2","doc":"iex> scale(parse!(\"P2M4DT6H\"), 1.5)\n    Interval.parse!(\"P3M6DT9H\")","ref":"PgInterop.Interval.html#scale/2-examples"},{"type":"function","title":"PgInterop.Interval.subtract/2","doc":"Subtracts the second interval from the first one","ref":"PgInterop.Interval.html#subtract/2"},{"type":"function","title":"Examples - PgInterop.Interval.subtract/2","doc":"iex> subtract(parse!(\"P2D\"), parse!(\"P1D\"))\n    Interval.parse!(\"P1D\")","ref":"PgInterop.Interval.html#subtract/2-examples"},{"type":"function","title":"PgInterop.Interval.subtract_from_date/2","doc":"Subtracts an interval from a given date or date-time to get a new date-time.\n\nAccepts `DateTime`, `NaiveDateTime`, and `Date`. Returns `DateTime` in the first case\nand `NaiveDateTime` in second  and third. If a plain `Date` is passed, midnight is assumed.","ref":"PgInterop.Interval.html#subtract_from_date/2"},{"type":"function","title":"Examples - PgInterop.Interval.subtract_from_date/2","doc":"iex> subtract_from_date(~D[2024-01-10], parse!(\"P2DT12H\"))\n    ~N[2024-01-07 12:00:00.000000]\n\n    iex> subtract_from_date(~N[2024-01-10 13:00:00], parse!(\"P2DT12H\"))\n    ~N[2024-01-08 01:00:00.000000]\n\n    iex> subtract_from_date(~U[2024-01-10 13:00:00Z], parse!(\"P2DT12H\"))\n    ~U[2024-01-08 01:00:00.000000Z]","ref":"PgInterop.Interval.html#subtract_from_date/2-examples"},{"type":"function","title":"PgInterop.Interval.zero/0","doc":"Zero-length interval, useful in reductions","ref":"PgInterop.Interval.html#zero/0"},{"type":"type","title":"PgInterop.Interval.t/0","doc":"","ref":"PgInterop.Interval.html#t:t/0"},{"type":"module","title":"PgInterop.Interval.ISO8601AlternativeParser","doc":"This module parses alternative ISO-8601 duration strings into Interval structs.","ref":"PgInterop.Interval.ISO8601AlternativeParser.html"},{"type":"function","title":"PgInterop.Interval.ISO8601AlternativeParser.parse/1","doc":"Parses an ISO-8601 formatted duration string into a Interval struct.\nThe parse result is wrapped in a :ok/:error tuple.","ref":"PgInterop.Interval.ISO8601AlternativeParser.html#parse/1"},{"type":"function","title":"Examples - PgInterop.Interval.ISO8601AlternativeParser.parse/1","doc":"iex> parse(\"P0015-3-2T1:14:37.25\")\n    {:ok, Interval.parse!(\"P15Y3M2DT1H14M37.25S\")}\n\n    iex> parse(\"P0015-3-2\")\n    {:ok, Interval.parse!(\"P15Y3M2D\")}\n\n    iex> parse(\"PT3:12:25.001\")\n    {:ok, Interval.parse!(\"PT3H12M25.001S\")}\n\n    iex> parse(\"P0015T30:00\")\n    {:ok, Interval.parse!(\"P15YT30H\")}\n\n    iex> parse(\"\")\n    {:error, \"input string cannot be empty\"}\n    iex> parse(\"W\")\n    {:error, \"expected P, got W\"}\n    iex> parse(\"P0015TT30:00\")\n    {:error, \"unexpected duplicate T\"}\n    iex> parse(\"P0015-3-2-1\")\n    {:error, \"unexpected 4th section in y-m-d part\"}\n    iex> parse(\"P0015-3-y\")\n    {:error, \"invalid number `y`\"}\n    iex> parse(\"P0015-3-1T30:00:10.y\")\n    {:error, \"invalid number `10.y`\"}","ref":"PgInterop.Interval.ISO8601AlternativeParser.html#parse/1-examples"},{"type":"function","title":"PgInterop.Interval.ISO8601AlternativeParser.split_on_time/1","doc":"","ref":"PgInterop.Interval.ISO8601AlternativeParser.html#split_on_time/1"},{"type":"function","title":"PgInterop.Interval.ISO8601AlternativeParser.validate_hms/1","doc":"","ref":"PgInterop.Interval.ISO8601AlternativeParser.html#validate_hms/1"},{"type":"function","title":"PgInterop.Interval.ISO8601AlternativeParser.validate_ymd/1","doc":"","ref":"PgInterop.Interval.ISO8601AlternativeParser.html#validate_ymd/1"},{"type":"module","title":"PgInterop.Interval.ISO8601Parser","doc":"This module parses ISO-8601 duration strings into Interval structs.\n\nImplementation taken from https://github.com/bitwalker/timex/blob/3.7.9/lib/parse/duration/parsers/iso8601.ex\nand adapted to fill a different structure + support negatives.","ref":"PgInterop.Interval.ISO8601Parser.html"},{"type":"function","title":"PgInterop.Interval.ISO8601Parser.parse/1","doc":"Parses an ISO-8601 formatted duration string into a Interval struct.\nThe parse result is wrapped in a :ok/:error tuple.","ref":"PgInterop.Interval.ISO8601Parser.html#parse/1"},{"type":"function","title":"Examples - PgInterop.Interval.ISO8601Parser.parse/1","doc":"iex> parse(\"P15Y3M2DT1H14M37.25S\")\n    {:ok, Interval.parse!(\"P15Y3M2DT1H14M37.25S\")}\n\n    iex> parse(\"P15Y3M2D\")\n    {:ok, Interval.parse!(\"P15Y3M2D\")}\n\n    iex> parse(\"PT3H12M25.001S\")\n    {:ok, Interval.parse!(\"PT3H12M25.001S\")}\n\n    iex> parse(\"P2W1D\")\n    {:ok, Interval.parse!(\"P15D\")}\n\n    iex> parse(\"\")\n    {:error, \"input string cannot be empty\"}\n    iex> parse(\"P15YT3D\")\n    {:error, \"invalid use of date component after time separator\"}\n    iex> parse(\"P15Y3H\")\n    {:error, \"missing T separator between date and time components\"}\n    iex> parse(\"P15YTT3H\")\n    {:error, \"encountered duplicate time separator T\"}\n\n    iex> parse(\"P1O\")\n    {:error, \"unexpected token O\"}\n    iex> parse(\"P1-1D\")\n    {:error, \"invalid number `1-1`\"}\n    iex> parse(\"P1\")\n    {:error, \"unexpected end of input at 1\"}\n    iex> parse(\"P11\")\n    {:error, \"unexpected end of input at 1\"}\n    iex> parse(\"PT\")\n    {:error, \"unexpected end of input at T\"}\n    iex> parse(\"PO\")\n    {:error, \"expected numeric, but got `O`\"}\n    iex> parse(\"O\")\n    {:error, \"expected P, got `O`\"}","ref":"PgInterop.Interval.ISO8601Parser.html#parse/1-examples"},{"type":"module","title":"PgInterop.Interval.Iso8601Formatter","doc":"","ref":"PgInterop.Interval.Iso8601Formatter.html"},{"type":"function","title":"PgInterop.Interval.Iso8601Formatter.format/1","doc":"Return a human readable string representing the duration, formatted according\nto ISO8601. Negative sections will be formatted accordingly, as does PG.","ref":"PgInterop.Interval.Iso8601Formatter.html#format/1"},{"type":"function","title":"Examples - PgInterop.Interval.Iso8601Formatter.format/1","doc":"iex> format(Interval.parse!(\"PT2S\"))\n    \"PT2S\"\n\n    iex> format(Interval.parse!(\"PT2.0001S\"))\n    \"PT2.0001S\"\n\n    iex> format(Interval.parse!(\"PT1M5S\"))\n    \"PT1M5S\"\n\n    iex> format(Interval.parse!(\"PT1M5S\"))\n    \"PT1M5S\"\n\n    iex> format(Interval.parse!(\"P45Y6M5DT21H12M34.590264S\"))\n    \"P45Y6M5DT21H12M34.590264S\"\n\n0-length interval is special-cased to render as \"0S\"\n\n    iex> format(%Interval{months: 0, days: 0, microseconds: 0})\n    \"PT0S\"","ref":"PgInterop.Interval.Iso8601Formatter.html#format/1-examples"},{"type":"module","title":"PgInterop.Interval.PostgresAndSQLParser","doc":"This module parses Postgres classic and SQL strings","ref":"PgInterop.Interval.PostgresAndSQLParser.html"},{"type":"function","title":"PgInterop.Interval.PostgresAndSQLParser.parse/1","doc":"Parses an Postgres classic and SQL formatted duration string into\na Interval struct. The parse result is wrapped in a :ok/:error tuple.","ref":"PgInterop.Interval.PostgresAndSQLParser.html#parse/1"},{"type":"function","title":"Examples - PgInterop.Interval.PostgresAndSQLParser.parse/1","doc":"iex> parse(\"1-2\")\n    {:ok, Interval.parse!(\"P1Y2M\")}\n\n    iex> parse(\"@ 1-2\")\n    {:ok, Interval.parse!(\"P1Y2M\")}\n\n    iex> parse(\"-1-2 +3 -4:05:06\")\n    {:ok, Interval.parse!(\"P-1Y-2M3DT-4H-5M-6S\")}\n\n    iex> parse(\"-1-2 -5:10.1\")\n    {:ok, Interval.parse!(\"P-1Y-2MT-5M-10.1S\")}\n\n    iex> parse(\"3 4:05:06\")\n    {:ok, Interval.parse!(\"P3DT4H5M6S\")}\n\n    iex> parse(\"1 year 2 months 3 days 4 hours 5 minutes 6 seconds\")\n    {:ok, Interval.parse!(\"P1Y2M3DT4H5M6S\")}\n\n    iex> parse(\"1 year 2-1 3 days +2\")\n    {:ok, Interval.parse!(\"P3Y1M3DT2S\")}\n\n    iex> parse(\"1 year 2-1 3 days -2\")\n    {:ok, Interval.parse!(\"P3Y1M3DT-2S\")}\n\n    iex> parse(\"1 year 2-1 3 days 2:2\")\n    {:ok, Interval.parse!(\"P3Y1M3DT2H2M\")}\n\n    iex> parse(\"1 year 2-1 3 days 2.2\")\n    {:ok, Interval.parse!(\"P3Y1M3DT2.2S\")}\n\n    iex> parse(\"-1-2 -5:10.1\")\n    {:ok, Interval.parse!(\"P-1Y-2MT-5M-10.1S\")}\n\n    iex> parse(\"1.3 cent 100-11 10.3\")\n    {:ok, Interval.parse!(\"P230Y11MT10.3S\")}\n\n    iex> parse(\"-   1 year -2 mons +3 days -  04:05:06\")\n    {:ok, Interval.parse!(\"P-1Y-2M3DT-4H-5M-6S\")}\n\n    iex> parse(\"0.1 mils 1 cent 1 decade 1 year 1 month 1 week 1 day 1 hour 1 minute 1 second 1000 ms 1000000 us\")\n    {:ok, Interval.parse!(\"P211Y1M8DT1H1M3S\")}\n\n    iex> parse(\"1.3 cent 100-11 10.3    1-1\")\n    {:error, \"invalid input syntax at `10.3`\"}\n\n    iex> parse(\"10 10:01  1 10:01:10\")\n    {:error, \"invalid input syntax\"}\n    iex> parse(\"1 month 1-10\")\n    {:error, \"invalid input syntax\"}\n    iex> parse(\"1-13\")\n    {:error, \"invalid input syntax\"}\n    iex> parse(\"1 minute 1 10:01:10\")\n    {:error, \"invalid input syntax\"}\n    iex> parse(\"1 second 1 10:01:10\")\n    {:error, \"invalid input syntax\"}\n    iex> parse(\"10 10:01 1\")\n    {:error, \"invalid input syntax\"}\n\n    iex> parse(\"\")\n    {:error, \"input string cannot be empty\"}","ref":"PgInterop.Interval.PostgresAndSQLParser.html#parse/1-examples"},{"type":"module","title":"PgInterop.Postgrex.Extensions.PgLsn","doc":"","ref":"PgInterop.Postgrex.Extensions.PgLsn.html"},{"type":"function","title":"PgInterop.Postgrex.Extensions.PgLsn.decode/1","doc":"","ref":"PgInterop.Postgrex.Extensions.PgLsn.html#decode/1"},{"type":"function","title":"PgInterop.Postgrex.Extensions.PgLsn.encode/1","doc":"","ref":"PgInterop.Postgrex.Extensions.PgLsn.html#encode/1"},{"type":"function","title":"PgInterop.Postgrex.Extensions.PgLsn.format/1","doc":"","ref":"PgInterop.Postgrex.Extensions.PgLsn.html#format/1"},{"type":"function","title":"PgInterop.Postgrex.Extensions.PgLsn.init/1","doc":"","ref":"PgInterop.Postgrex.Extensions.PgLsn.html#init/1"},{"type":"function","title":"PgInterop.Postgrex.Extensions.PgLsn.matching/1","doc":"","ref":"PgInterop.Postgrex.Extensions.PgLsn.html#matching/1"},{"type":"extras","title":"Electric","doc":"# Electric\n\nElectric Sync is a lightweight data synchronization service designed to sync small subsets of your Postgres data into various environments and applications, such as web and mobile apps, development environments, edge services, and local AI systems.","ref":"readme.html"},{"type":"extras","title":"Key Use Cases: - Electric","doc":"- **Web & Mobile Apps**: Replaces traditional data fetching by syncing necessary data directly into your apps.\n- **Development Environments**: Synchronizes data into embedded databases like PGlite, facilitating local testing.\n- **Edge Workers & Services**: Maintains low-latency data caches for edge services.\n- **Local AI Systems**: Syncs data into AI systems utilizing pgvector for efficient, local data handling.","ref":"readme.html#key-use-cases"},{"type":"extras","title":"How it Works: - Electric","doc":"Electric Sync is powered by an Elixir-based application that connects to your Postgres database via a `DATABASE_URL`. It consumes the logical replication stream and exposes an HTTP API for replicating data subsets, or \"Shapes,\" to local environments.\n\nFor a quick setup and examples, refer to the [Quickstart guide](https://electric-sql.com/docs/quickstart).","ref":"readme.html#how-it-works"},{"type":"extras","title":"Running - Electric","doc":"Run Postgres:\n\n```sh\ndocker compose -f dev/docker-compose.yml create\ndocker compose -f dev/docker-compose.yml start\n```\n\nSource the `.env.dev` somehow, e.g.:\n\n```sh\nset -a; source .env.dev; set +a\n```\n\nRun the Elixir app:\n\n```sh\nmix deps.get\niex -S mix\n```","ref":"readme.html#running"}],"producer":{"name":"ex_doc","version":[48,46,51,52,46,50]},"content_type":"text/markdown"}